"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getDefaultMap = exports.getDefaultMapLeft = void 0;
/**
 * @since 3.0.0
 */
var function_1 = require("./function");
// -------------------------------------------------------------------------------------
// defaults
// -------------------------------------------------------------------------------------
/**
 * Returns a default `mapLeft` implementation from `mapBoth`.
 *
 * @category defaults
 * @since 3.0.0
 */
var getDefaultMapLeft = function (mapBoth) {
    return function (f) {
        return mapBoth(f, function_1.identity);
    };
};
exports.getDefaultMapLeft = getDefaultMapLeft;
/**
 * Returns a default `map` implementation from `mapBoth`.
 *
 * @category defaults
 * @since 3.0.0
 */
var getDefaultMap = function (mapBoth) {
    return function (f) {
        return mapBoth(function_1.identity, f);
    };
};
exports.getDefaultMap = getDefaultMap;
