"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getApplicative = exports.getApply = exports.Bifunctor = exports.Contravariant = exports.flap = exports.Functor = exports.map = exports.getBooleanAlgebra = exports.getHeytingAlgebra = exports.getRing = exports.getSemiring = exports.getMonoid = exports.getSemigroup = exports.getShow = exports.getBounded = exports.getOrd = exports.getEq = exports.mapBoth = exports.mapLeft = exports.contramap = exports.make = void 0;
var eq = __importStar(require("./Eq"));
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
var ord = __importStar(require("./Ord"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
var make = function (s) {
    return (0, function_1.unsafeCoerce)({
        value: s
    });
};
exports.make = make;
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var contramap = function () { return function_1.unsafeCoerce; };
exports.contramap = contramap;
/**
 * @since 3.0.0
 */
var mapLeft = function (f) { return function (self) {
    return (0, exports.make)(f(self.value));
}; };
exports.mapLeft = mapLeft;
/**
 * @since 3.0.0
 */
exports.mapBoth = (0, function_1.unsafeCoerce)(exports.mapLeft);
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
exports.getEq = eq.contramap(function (c) { return c.value; });
/**
 * @category instances
 * @since 3.0.0
 */
exports.getOrd = ord.contramap(function (c) { return c.value; });
/**
 * @category instances
 * @since 3.0.0
 */
var getBounded = function (B) { return ({
    compare: (0, exports.getOrd)(B).compare,
    top: (0, exports.make)(B.top),
    bottom: (0, exports.make)(B.bottom)
}); };
exports.getBounded = getBounded;
/**
 * @category instances
 * @since 3.0.0
 */
var getShow = function (S) { return ({
    show: function (c) { return "make(".concat(S.show(c.value), ")"); }
}); };
exports.getShow = getShow;
/**
 * @category instances
 * @since 3.0.0
 */
var getSemigroup = function (S) { return ({
    combine: function (that) { return function (self) { return (0, exports.make)(S.combine(that.value)(self.value)); }; }
}); };
exports.getSemigroup = getSemigroup;
/**
 * @category instances
 * @since 3.0.0
 */
var getMonoid = function (M) { return ({
    combine: (0, exports.getSemigroup)(M).combine,
    empty: (0, exports.make)(M.empty)
}); };
exports.getMonoid = getMonoid;
/**
 * @category instances
 * @since 3.0.0
 */
var getSemiring = function (S) { return ({
    add: function (that) { return function (self) { return (0, exports.make)(S.add(that.value)(self.value)); }; },
    mul: function (that) { return function (self) { return (0, exports.make)(S.mul(that.value)(self.value)); }; },
    one: (0, exports.make)(S.one),
    zero: (0, exports.make)(S.zero)
}); };
exports.getSemiring = getSemiring;
/**
 * @category instances
 * @since 3.0.0
 */
var getRing = function (R) {
    var S = (0, exports.getSemiring)(R);
    return {
        add: S.add,
        mul: S.mul,
        one: S.one,
        zero: S.zero,
        sub: function (that) { return function (self) { return (0, exports.make)(R.sub(that.value)(self.value)); }; }
    };
};
exports.getRing = getRing;
// TODO Field
/**
 * @category instances
 * @since 3.0.0
 */
var getHeytingAlgebra = function (H) {
    return {
        implies: function (that) { return function (self) { return (0, exports.make)(H.implies(that.value)(self.value)); }; },
        not: function (c) { return (0, exports.make)(H.not(c.value)); },
        join: function (that) { return function (self) { return (0, exports.make)(H.join(that.value)(self.value)); }; },
        meet: function (that) { return function (self) { return (0, exports.make)(H.meet(that.value)(self.value)); }; },
        one: (0, exports.make)(H.one),
        zero: (0, exports.make)(H.zero)
    };
};
exports.getHeytingAlgebra = getHeytingAlgebra;
/**
 * @category instances
 * @since 3.0.0
 */
exports.getBooleanAlgebra = exports.getHeytingAlgebra;
/**
 * @category Functor
 * @since 3.0.0
 */
var map = function () { return function_1.unsafeCoerce; };
exports.map = map;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flap = functor.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Contravariant = {
    contramap: exports.contramap
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    mapBoth: exports.mapBoth
};
/**
 * @category instances
 * @since 3.0.0
 */
var getApply = function (S) { return ({
    map: exports.map,
    ap: function (fa) { return function (self) { return (0, exports.make)(S.combine(fa.value)(self.value)); }; }
}); };
exports.getApply = getApply;
/**
 * @category instances
 * @since 3.0.0
 */
var getApplicative = function (M) {
    var A = (0, exports.getApply)(M);
    var empty = (0, exports.make)(M.empty);
    return {
        map: A.map,
        ap: A.ap,
        of: function () { return empty; }
    };
};
exports.getApplicative = getApplicative;
