"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.bracket = exports.toUnion = exports.swap = exports.tapLeft = exports.orElse = exports.getOrElseE = exports.getOrElse = exports.matchWithEffect = exports.match = exports.getValidatedCombineK = exports.mapLeft = exports.mapBoth = exports.combineK = exports.flatMap = exports.ap = exports.map = exports.leftF = exports.rightF = exports.left = exports.right = void 0;
/**
 * @since 3.0.0
 */
var apply = __importStar(require("./Apply"));
var either = __importStar(require("./Either"));
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var right = function (F) {
    return function (a) {
        return F.of(either.right(a));
    };
};
exports.right = right;
/**
 * @since 3.0.0
 */
var left = function (F) {
    return function (e) {
        return F.of(either.left(e));
    };
};
exports.left = left;
/**
 * @since 3.0.0
 */
function rightF(F) {
    return F.map(either.right);
}
exports.rightF = rightF;
/**
 * @since 3.0.0
 */
function leftF(F) {
    return F.map(either.left);
}
exports.leftF = leftF;
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * Returns an effect whose success is mapped by the specified `f` function.
 *
 * @since 3.0.0
 */
var map = function (F) {
    return functor.getMapComposition(F, either.Functor);
};
exports.map = map;
/**
 * @since 3.0.0
 */
var ap = function (F) {
    return apply.getApComposition(F, either.Apply);
};
exports.ap = ap;
/**
 * @since 3.0.0
 */
var flatMap = function (M) {
    return function (f) {
        return function (self) {
            return (0, function_1.pipe)(self, M.flatMap(function (e) { return (either.isLeft(e) ? M.of(e) : f(e.right)); }));
        };
    };
};
exports.flatMap = flatMap;
/**
 * @since 3.0.0
 */
var combineK = function (M) {
    return function (second) {
        return function (first) {
            return (0, function_1.pipe)(first, M.flatMap(function (e) {
                return either.isLeft(e) ? second() : M.of(e);
            }));
        };
    };
};
exports.combineK = combineK;
/**
 * Returns an effect whose failure and success channels have been mapped by
 * the specified pair of functions, `f` and `g`.
 *
 * @category type class operations
 * @since 3.0.0
 */
var mapBoth = function (F) {
    return (0, function_1.flow)(either.mapBoth, F.map);
};
exports.mapBoth = mapBoth;
/**
 * @category type class operations
 * @since 3.0.0
 */
var mapLeft = function (F) {
    return function (f) {
        return F.map(either.mapError(f));
    };
};
exports.mapLeft = mapLeft;
/**
 * @since 3.0.0
 */
var getValidatedCombineK = function (M, S) {
    return function (second) {
        return function (first) {
            var rightM = (0, exports.right)(M);
            return (0, function_1.pipe)(first, M.flatMap(either.match(function (e1) { return (0, function_1.pipe)(second(), M.map(either.mapError(function (e2) { return S.combine(e2)(e1); }))); }, rightM)));
        };
    };
};
exports.getValidatedCombineK = getValidatedCombineK;
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function match(F) {
    return (0, function_1.flow)(either.match, F.map);
}
exports.match = match;
/**
 * @since 3.0.0
 */
var matchWithEffect = function (M) {
    return function (onError, onSuccess) {
        return M.flatMap(either.match(onError, onSuccess));
    };
};
exports.matchWithEffect = matchWithEffect;
/**
 * @since 3.0.0
 */
var getOrElse = function (F) {
    return function (onError) {
        return F.map(either.getOrElse(onError));
    };
};
exports.getOrElse = getOrElse;
/**
 * @since 3.0.0
 */
var getOrElseE = function (M) {
    return function (onError) {
        return function (self) {
            return (0, function_1.pipe)(self, M.flatMap(either.match(onError, M.of)));
        };
    };
};
exports.getOrElseE = getOrElseE;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var orElse = function (M) {
    return function (onError) {
        return function (self) {
            return (0, function_1.pipe)(self, M.flatMap(function (e) {
                return either.isLeft(e) ? onError(e.left) : M.of(e);
            }));
        };
    };
};
exports.orElse = orElse;
/**
 * Returns an effect that effectfully "peeks" at the failure of this effect.
 *
 * @category combinatorsError
 * @since 3.0.0
 */
var tapLeft = function (M) {
    var orElseM = (0, exports.orElse)(M);
    return function (onError) {
        return function (self) {
            return (0, function_1.pipe)(self, orElseM(function (e) {
                return (0, function_1.pipe)(onError(e), M.map(function (eb) { return (either.isLeft(eb) ? eb : either.left(e)); }));
            }));
        };
    };
};
exports.tapLeft = tapLeft;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function swap(F) {
    return F.map(either.swap);
}
exports.swap = swap;
/**
 * @since 3.0.0
 */
function toUnion(F) {
    return F.map(either.toUnion);
}
exports.toUnion = toUnion;
/**
 * @since 3.0.0
 */
var bracket = function (M) {
    return function (acquire, use, release) {
        var leftM = (0, exports.left)(M);
        return (0, function_1.pipe)(acquire, M.flatMap(either.match(leftM, function (a) {
            return (0, function_1.pipe)(use(a), M.flatMap(function (e) {
                return (0, function_1.pipe)(release(a, e), M.flatMap(either.match(leftM, function () { return M.of(e); })));
            }));
        })));
    };
};
exports.bracket = bracket;
