"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.partitionWithEffect = exports.filterWithEffect = exports.getDefaultFilterMapWithEffect = exports.getDefaultPartitionMapWithEffect = void 0;
var function_1 = require("./function");
var _ = __importStar(require("./internal"));
// -------------------------------------------------------------------------------------
// defaults
// -------------------------------------------------------------------------------------
/**
 * Return a `partitionMapWithEffect` implementation from `Traversable` and `Compactable`.
 *
 * @category defaults
 * @since 3.0.0
 */
function getDefaultPartitionMapWithEffect(T, C) {
    return function (F) {
        var traverseF = T.traverse(F);
        return function (f) {
            return (0, function_1.flow)(traverseF(f), F.map(C.separate));
        };
    };
}
exports.getDefaultPartitionMapWithEffect = getDefaultPartitionMapWithEffect;
/**
 * Return a `filterMapWithEffect` implementation from `Traversable` and `Compactable`.
 *
 * @category defaults
 * @since 3.0.0
 */
function getDefaultFilterMapWithEffect(T, C) {
    return function (F) {
        var traverseF = T.traverse(F);
        return function (f) {
            return (0, function_1.flow)(traverseF(f), F.map(C.compact));
        };
    };
}
exports.getDefaultFilterMapWithEffect = getDefaultFilterMapWithEffect;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * Filter values inside a `F` context.
 *
 * @category combinators
 * @since 3.0.0
 */
var filterWithEffect = function (FilterableWithEffectμ) {
    return function (Applicativeλ) {
        var filterMapWithEffectλ = FilterableWithEffectμ.filterMapWithEffect(Applicativeλ);
        return function (predicateK) {
            return filterMapWithEffectλ(function (b) {
                return (0, function_1.pipe)(predicateK(b), Applicativeλ.map(function (bool) { return (bool ? _.some(b) : _.none); }));
            });
        };
    };
};
exports.filterWithEffect = filterWithEffect;
/**
 * Partition values inside a `F` context.
 *
 * @category combinators
 * @since 3.0.0
 */
var partitionWithEffect = function (FilterableWithEffectμ) {
    return function (Applicativeλ) {
        var partitionMapWithEffectλ = FilterableWithEffectμ.partitionMapWithEffect(Applicativeλ);
        return function (predicateK) {
            return partitionMapWithEffectλ(function (b) {
                return (0, function_1.pipe)(predicateK(b), Applicativeλ.map(function (bool) { return (bool ? _.right(b) : _.left(b)); }));
            });
        };
    };
};
exports.partitionWithEffect = partitionWithEffect;
