"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.bind = exports.tap = exports.ap = void 0;
var function_1 = require("./function");
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var ap = function (M) {
    return function (fa) {
        return function (fab) {
            return (0, function_1.pipe)(fab, M.flatMap(function (f) { return (0, function_1.pipe)(fa, M.map(f)); }));
        };
    };
};
exports.ap = ap;
/**
 * Returns an effect that effectfully "peeks" at the success of this effect.
 *
 * @category combinators
 * @since 3.0.0
 */
var tap = function (M) {
    return function (f) {
        return M.flatMap(function (a) {
            return (0, function_1.pipe)(f(a), M.map(function () { return a; }));
        });
    };
};
exports.tap = tap;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var bind = function (M) {
    return function (name, f) {
        return M.flatMap(function (a) {
            return (0, function_1.pipe)(f(a), M.map(function (b) {
                var _a;
                return Object.assign({}, a, (_a = {}, _a[name] = b, _a));
            }));
        });
    };
};
exports.bind = bind;
