"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.flatMapNullableK = exports.fromNullableK = exports.fromNullable = exports.partition = exports.filter = exports.partitionMap = exports.filterMap = exports.flatMapEitherK = exports.fromEitherK = exports.flatMapOptionK = exports.fromOptionK = exports.fromPredicate = exports.fromOption = void 0;
var function_1 = require("./function");
var _ = __importStar(require("./internal"));
var Predicate_1 = require("./Predicate");
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
var fromOption = function (F) {
    return function (onNone) {
        var fromOption = _.fromOption(onNone);
        return function (ma) { return F.fromEither(fromOption(ma)); };
    };
};
exports.fromOption = fromOption;
/**
 * @category constructors
 * @since 3.0.0
 */
var fromPredicate = function (F) {
    return function (predicate, onFalse) {
        return function (b) {
            return F.fromEither(predicate(b) ? _.right(b) : _.left(onFalse(b)));
        };
    };
};
exports.fromPredicate = fromPredicate;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var fromOptionK = function (F) {
    return function (f, onNone) {
        return function () {
            var a = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                a[_i] = arguments[_i];
            }
            return F.fromEither(_.fromOptionOrElse(f.apply(void 0, a), function () { return onNone.apply(void 0, a); }));
        };
    };
};
exports.fromOptionK = fromOptionK;
/**
 * @category combinators
 * @since 3.0.0
 */
var flatMapOptionK = function (F, M) {
    var fromOptionKF = (0, exports.fromOptionK)(F);
    return function (f, onNone) {
        var from = fromOptionKF(f, onNone);
        return function (self) {
            return (0, function_1.pipe)(self, M.flatMap(from));
        };
    };
};
exports.flatMapOptionK = flatMapOptionK;
/**
 * @category combinators
 * @since 3.0.0
 */
var fromEitherK = function (F) {
    return function (f) {
        return function () {
            var a = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                a[_i] = arguments[_i];
            }
            return F.fromEither(f.apply(void 0, a));
        };
    };
};
exports.fromEitherK = fromEitherK;
/**
 * @category combinators
 * @since 3.0.0
 */
var flatMapEitherK = function (F, M) {
    var fromEitherKF = (0, exports.fromEitherK)(F);
    return function (f) {
        return function (self) {
            return (0, function_1.pipe)(self, M.flatMap(fromEitherKF(f)));
        };
    };
};
exports.flatMapEitherK = flatMapEitherK;
/**
 * @category combinators
 * @since 3.0.0
 */
var filterMap = function (F, M) {
    return function (f, onNone) {
        return M.flatMap(function (a) {
            var ob = f(a);
            return F.fromEither(_.isNone(ob) ? _.left(onNone(a)) : _.right(ob.value));
        });
    };
};
exports.filterMap = filterMap;
/**
 * @category combinators
 * @since 3.0.0
 */
var partitionMap = function (F, M) {
    return function (f, onEmpty) {
        return function (self) {
            var filterMapFM = (0, exports.filterMap)(F, M);
            return [(0, function_1.pipe)(self, filterMapFM((0, function_1.flow)(f, _.getLeft), onEmpty)), (0, function_1.pipe)(self, filterMapFM((0, function_1.flow)(f, _.getRight), onEmpty))];
        };
    };
};
exports.partitionMap = partitionMap;
/**
 * @category combinators
 * @since 3.0.0
 */
var filter = function (F, M) {
    return function (predicate, onFalse) {
        return M.flatMap(function (b) { return F.fromEither(predicate(b) ? _.right(b) : _.left(onFalse(b))); });
    };
};
exports.filter = filter;
/**
 * @category combinators
 * @since 3.0.0
 */
var partition = function (F, M) {
    return function (predicate, onFalse) {
        return function (self) {
            var filterFM = (0, exports.filter)(F, M);
            return [(0, function_1.pipe)(self, filterFM((0, Predicate_1.not)(predicate), onFalse)), (0, function_1.pipe)(self, filterFM(predicate, onFalse))];
        };
    };
};
exports.partition = partition;
// -------------------------------------------------------------------------------------
// interop
// -------------------------------------------------------------------------------------
/**
 * @category interop
 * @since 3.0.0
 */
var fromNullable = function (F) {
    return function (onNullable) {
        return function (a) {
            return F.fromEither(_.fromNullableOrElse(a, onNullable));
        };
    };
};
exports.fromNullable = fromNullable;
/**
 * @category interop
 * @since 3.0.0
 */
var fromNullableK = function (F) {
    var fromNullableF = (0, exports.fromNullable)(F);
    return function (onNullable) {
        var fromNullable = fromNullableF(onNullable);
        return function (f) {
            return function () {
                var a = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    a[_i] = arguments[_i];
                }
                return fromNullable(f.apply(void 0, a));
            };
        };
    };
};
exports.fromNullableK = fromNullableK;
/**
 * @category interop
 * @since 3.0.0
 */
var flatMapNullableK = function (F, M) {
    var fromNullableKM = (0, exports.fromNullableK)(F);
    return function (onNullable) {
        var fromNullable = fromNullableKM(onNullable);
        return function (f) {
            return function (self) {
                return (0, function_1.pipe)(self, M.flatMap(fromNullable(f)));
            };
        };
    };
};
exports.flatMapNullableK = flatMapNullableK;
