"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.logError = exports.log = exports.flatMapIOK = exports.fromIOK = void 0;
var function_1 = require("./function");
var console = __importStar(require("./Console"));
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var fromIOK = function (F) {
    return function (f) {
        return function () {
            var a = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                a[_i] = arguments[_i];
            }
            return F.fromIO(f.apply(void 0, a));
        };
    };
};
exports.fromIOK = fromIOK;
/**
 * @category combinators
 * @since 3.0.0
 */
var flatMapIOK = function (F, M) {
    return function (f) {
        return function (self) {
            return (0, function_1.pipe)(self, M.flatMap(function (a) { return F.fromIO(f(a)); }));
        };
    };
};
exports.flatMapIOK = flatMapIOK;
// -------------------------------------------------------------------------------------
// logging
// -------------------------------------------------------------------------------------
/**
 * @category logging
 * @since 3.0.0
 */
var log = function (F) {
    return function () {
        var x = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            x[_i] = arguments[_i];
        }
        return F.fromIO(console.log.apply(console, x));
    };
};
exports.log = log;
/**
 * @category logging
 * @since 3.0.0
 */
var logError = function (F) {
    return function () {
        var x = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            x[_i] = arguments[_i];
        }
        return F.fromIO(console.error.apply(console, x));
    };
};
exports.logError = logError;
