"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.flatMapTaskK = exports.fromTaskK = void 0;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var fromTaskK = function (F) {
    return function (f) {
        return function () {
            var a = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                a[_i] = arguments[_i];
            }
            return F.fromTask(f.apply(void 0, a));
        };
    };
};
exports.fromTaskK = fromTaskK;
/**
 * @category combinators
 * @since 3.0.0
 */
var flatMapTaskK = function (F, M) {
    return function (f) { return M.flatMap(function (a) { return F.fromTask(f(a)); }); };
};
exports.flatMapTaskK = flatMapTaskK;
