"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fromOption = exports.FromEither = exports.flatMapIOK = exports.fromIOK = exports.logError = exports.log = exports.FromIO = exports.SemigroupK = exports.tapError = exports.Monad = exports.ApplicativeSeq = exports.ApplySeq = exports.tap = exports.Flattenable = exports.ApplicativePar = exports.zipRightPar = exports.zipLeftPar = exports.ApplyPar = exports.Bifunctor = exports.Pointed = exports.flap = exports.Functor = exports.getFilterable = exports.getCompactable = exports.getValidatedSemigroupK = exports.getValidatedApplicative = exports.combineK = exports.flatten = exports.flatMap = exports.unit = exports.of = exports.ap = exports.mapError = exports.mapBoth = exports.map = exports.swap = exports.orElse = exports.toUnion = exports.tryCatchK = exports.tryCatch = exports.getOrElseE = exports.getOrElse = exports.matchWithEffect = exports.match = exports.fromIO = exports.fromEither = exports.leftIO = exports.rightIO = exports.right = exports.left = void 0;
exports.sequenceReadonlyArraySeq = exports.traverseReadonlyArraySeq = exports.traverseReadonlyNonEmptyArraySeq = exports.traverseReadonlyArrayWithIndexSeq = exports.traverseReadonlyNonEmptyArrayWithIndexSeq = exports.sequenceReadonlyArray = exports.traverseReadonlyArray = exports.traverseReadonlyNonEmptyArray = exports.traverseReadonlyArrayWithIndex = exports.traverseReadonlyNonEmptyArrayWithIndex = exports.apT = exports.tupled = exports.ApT = exports.bindPar = exports.bind = exports.let = exports.bindTo = exports.Do = exports.bracket = exports.flatMapNullableK = exports.fromNullableK = exports.fromNullable = exports.fromEitherK = exports.partitionMap = exports.partition = exports.filterMap = exports.filter = exports.fromPredicate = exports.flatMapEitherK = exports.flatMapOptionK = exports.fromOptionK = void 0;
var apply = __importStar(require("./Apply"));
var flattenable = __importStar(require("./Flattenable"));
var compactable = __importStar(require("./Compactable"));
var either = __importStar(require("./Either"));
var eitherT = __importStar(require("./EitherT"));
var fromEither_ = __importStar(require("./FromEither"));
var fromIO_ = __importStar(require("./FromIO"));
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var io = __importStar(require("./IO"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
exports.left = eitherT.left(io.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.right = eitherT.right(io.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.rightIO = eitherT.rightF(io.Functor);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.leftIO = eitherT.leftF(io.Functor);
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromEither = io.of;
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromIO = exports.rightIO;
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @category destructors
 * @since 3.0.0
 */
exports.match = eitherT.match(io.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.matchWithEffect = eitherT.matchWithEffect(io.Monad);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.getOrElse = 
/*#__PURE__*/ eitherT.getOrElse(io.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.getOrElseE = 
/*#__PURE__*/ eitherT.getOrElseE(io.Monad);
// -------------------------------------------------------------------------------------
// interop
// -------------------------------------------------------------------------------------
/**
 * Constructs a new `IOEither` from a function that performs a side effect and might throw.
 *
 * See also [`tryCatchK`](#tryCatchK).
 *
 * @category interop
 * @since 3.0.0
 */
var tryCatch = function (f, onThrow) {
    return function () {
        return either.tryCatch(f, onThrow);
    };
};
exports.tryCatch = tryCatch;
/**
 * Converts a function that may throw to one returning a `IOEither`.
 *
 * @category interop
 * @since 3.0.0
 */
var tryCatchK = function (f, onThrow) {
    return function () {
        var a = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            a[_i] = arguments[_i];
        }
        return (0, exports.tryCatch)(function () { return f.apply(void 0, a); }, onThrow);
    };
};
exports.tryCatchK = tryCatchK;
/**
 * @category interop
 * @since 3.0.0
 */
exports.toUnion = eitherT.toUnion(io.Functor);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.orElse = eitherT.orElse(io.Monad);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.swap = eitherT.swap(io.Functor);
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * Returns an effect whose success is mapped by the specified `f` function.
 *
 * @category Functor
 * @since 3.0.0
 */
exports.map = eitherT.map(io.Functor);
/**
 * Returns an effect whose failure and success channels have been mapped by
 * the specified pair of functions, `f` and `g`.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.mapBoth = 
/*#__PURE__*/ eitherT.mapBoth(io.Functor);
/**
 * Returns an effect with its error channel mapped using the specified
 * function. This can be used to lift a "smaller" error into a "larger" error.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.mapError = 
/*#__PURE__*/ eitherT.mapLeft(io.Functor);
/**
 * Apply a function to an argument under a type constructor.
 *
 * @category Apply
 * @since 3.0.0
 */
exports.ap = 
/*#__PURE__*/ eitherT.ap(io.Apply);
/**
 * @category Pointed
 * @since 3.0.0
 */
exports.of = exports.right;
/**
 * @since 3.0.0
 */
exports.unit = (0, exports.of)(undefined);
/**
 * Composes computations in sequence, using the return value of one computation to determine the next computation.
 *
 * @category Flattenable
 * @since 3.0.0
 */
exports.flatMap = 
/*#__PURE__*/ eitherT.flatMap(io.Monad);
/**
 * Derivable from `Flattenable`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flatten = 
/*#__PURE__*/ (0, exports.flatMap)(function_1.identity);
/**
 * Identifies an associative operation on a type constructor. It is similar to `Semigroup`, except that it applies to
 * types of kind `* -> *`.
 *
 * @category SemigroupK
 * @since 3.0.0
 */
exports.combineK = eitherT.combineK(io.Monad);
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * The default [`ApplicativePar`](#applicativepar) instance returns the first error, if you want to
 * get all errors you need to provide an way to combine them via a `Semigroup`.
 *
 * See [`getValidatedApplicative`](./Either.ts.html#getvalidatedapplicative).
 *
 * @category instances
 * @since 3.0.0
 */
var getValidatedApplicative = function (S) { return ({
    map: exports.map,
    ap: apply.getApComposition(io.Apply, either.getValidatedApplicative(S)),
    of: exports.of
}); };
exports.getValidatedApplicative = getValidatedApplicative;
/**
 * The default [`SemigroupK`](#semigroupk) instance returns the last error, if you want to
 * get all errors you need to provide an way to combine them via a `Semigroup`.
 *
 * @category instances
 * @since 3.0.0
 */
var getValidatedSemigroupK = function (S) {
    return {
        combineK: eitherT.getValidatedCombineK(io.Monad, S)
    };
};
exports.getValidatedSemigroupK = getValidatedSemigroupK;
/**
 * @category instances
 * @since 3.0.0
 */
var getCompactable = function (M) {
    var C = either.getCompactable(M);
    var F = { map: either.map };
    return {
        compact: compactable.getCompactComposition(io.Functor, C),
        separate: compactable.getSeparateComposition(io.Functor, C, F)
    };
};
exports.getCompactable = getCompactable;
/**
 * @category instances
 * @since 3.0.0
 */
var getFilterable = function (M) {
    return {
        partitionMap: function (f) { return (0, exports.partitionMap)(f, function () { return M.empty; }); },
        filterMap: function (f) { return (0, exports.filterMap)(f, function () { return M.empty; }); }
    };
};
exports.getFilterable = getFilterable;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/ functor.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Pointed = {
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    mapBoth: exports.mapBoth
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplyPar = {
    map: exports.map,
    ap: exports.ap
};
/**
 * Returns an effect that executes both this effect and the specified effect,
 * in parallel, this effect result returned. If either side fails, then the
 * other side will **NOT** be interrupted.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.zipLeftPar = 
/*#__PURE__*/ apply.zipLeftPar(exports.ApplyPar);
/**
 * Returns an effect that executes both this effect and the specified effect,
 * in parallel, returning result of provided effect. If either side fails,
 * then the other side will **NOT** be interrupted.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.zipRightPar = 
/*#__PURE__*/ apply.zipRightPar(exports.ApplyPar);
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplicativePar = {
    map: exports.map,
    ap: exports.ap,
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Flattenable = {
    map: exports.map,
    flatMap: exports.flatMap
};
/**
 * Returns an effect that effectfully "peeks" at the success of this effect.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.tap = 
/*#__PURE__*/ flattenable.tap(exports.Flattenable);
var apSeq = /*#__PURE__*/ flattenable.ap(exports.Flattenable);
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplySeq = {
    map: exports.map,
    ap: apSeq
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplicativeSeq = {
    map: exports.map,
    ap: apSeq,
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Monad = {
    map: exports.map,
    of: exports.of,
    flatMap: exports.flatMap
};
/**
 * Returns an effect that effectfully "peeks" at the failure of this effect.
 *
 * @category combinatorsError
 * @since 3.0.0
 */
exports.tapError = eitherT.tapLeft(io.Monad);
/**
 * @category instances
 * @since 3.0.0
 */
exports.SemigroupK = {
    combineK: exports.combineK
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromIO = {
    fromIO: exports.fromIO
};
// -------------------------------------------------------------------------------------
// logging
// -------------------------------------------------------------------------------------
/**
 * @category logging
 * @since 3.0.0
 */
exports.log = fromIO_.log(exports.FromIO);
/**
 * @category logging
 * @since 3.0.0
 */
exports.logError = fromIO_.logError(exports.FromIO);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromIOK = 
/*#__PURE__*/ fromIO_.fromIOK(exports.FromIO);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flatMapIOK = 
/*#__PURE__*/ fromIO_.flatMapIOK(exports.FromIO, exports.Flattenable);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromEither = {
    fromEither: exports.fromEither
};
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromOption = 
/*#__PURE__*/ fromEither_.fromOption(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromOptionK = fromEither_.fromOptionK(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flatMapOptionK = fromEither_.flatMapOptionK(exports.FromEither, exports.Flattenable);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flatMapEitherK = fromEither_.flatMapEitherK(exports.FromEither, exports.Flattenable);
/**
 * Derivable from `FromEither`.
 *
 * @category constructors
 * @since 3.0.0
 */
exports.fromPredicate = fromEither_.fromPredicate(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.filter = fromEither_.filter(exports.FromEither, exports.Flattenable);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.filterMap = fromEither_.filterMap(exports.FromEither, exports.Flattenable);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.partition = fromEither_.partition(exports.FromEither, exports.Flattenable);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.partitionMap = fromEither_.partitionMap(exports.FromEither, exports.Flattenable);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromEitherK = fromEither_.fromEitherK(exports.FromEither);
/**
 * @category interop
 * @since 3.0.0
 */
exports.fromNullable = 
/*#__PURE__*/ fromEither_.fromNullable(exports.FromEither);
/**
 * @category interop
 * @since 3.0.0
 */
exports.fromNullableK = fromEither_.fromNullableK(exports.FromEither);
/**
 * @category interop
 * @since 3.0.0
 */
exports.flatMapNullableK = 
/*#__PURE__*/ fromEither_.flatMapNullableK(exports.FromEither, exports.Flattenable);
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * Make sure that a resource is cleaned up in the event of an exception (\*). The release action is called regardless of
 * whether the body action throws (\*) or returns.
 *
 * (\*) i.e. returns a `Left`
 *
 * @since 3.0.0
 */
exports.bracket = eitherT.bracket(io.Monad);
// -------------------------------------------------------------------------------------
// do notation
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.Do = (0, exports.of)(_.emptyRecord);
/**
 * @since 3.0.0
 */
exports.bindTo = functor.bindTo(exports.Functor);
var let_ = 
/*#__PURE__*/ functor.let(exports.Functor);
exports.let = let_;
/**
 * @since 3.0.0
 */
exports.bind = 
/*#__PURE__*/ flattenable.bind(exports.Flattenable);
/**
 * @since 3.0.0
 */
exports.bindPar = 
/*#__PURE__*/ apply.bindPar(exports.ApplyPar);
// -------------------------------------------------------------------------------------
// sequence T
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.ApT = (0, exports.of)(_.emptyReadonlyArray);
/**
 * @since 3.0.0
 */
exports.tupled = functor.tupled(exports.Functor);
/**
 * @since 3.0.0
 */
exports.apT = 
/*#__PURE__*/ apply.apT(exports.ApplyPar);
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
// --- Par ---
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(ApplyPar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndex = function (f) {
    return (0, function_1.flow)(io.traverseReadonlyNonEmptyArrayWithIndex(f), io.map(either.traverseReadonlyNonEmptyArrayWithIndex(function_1.SK)));
};
exports.traverseReadonlyNonEmptyArrayWithIndex = traverseReadonlyNonEmptyArrayWithIndex;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(ApplicativePar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndex = function (f) {
    var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(f);
    return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
};
exports.traverseReadonlyArrayWithIndex = traverseReadonlyArrayWithIndex;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(ApplyPar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArray = function (f) {
    return (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(function (_, a) { return f(a); });
};
exports.traverseReadonlyNonEmptyArray = traverseReadonlyNonEmptyArray;
/**
 * Equivalent to `ReadonlyArray#traverse(ApplicativePar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArray = function (f) {
    return (0, exports.traverseReadonlyArrayWithIndex)(function (_, a) { return f(a); });
};
exports.traverseReadonlyArray = traverseReadonlyArray;
/**
 * Equivalent to `ReadonlyArray#sequence(ApplicativePar)`.
 *
 * @since 3.0.0
 */
exports.sequenceReadonlyArray = 
/*#__PURE__*/ (0, exports.traverseReadonlyArray)(function_1.identity);
// --- Seq ---
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(ApplySeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndexSeq = function (f) {
    return function (as) {
        return function () {
            var e = f(0, _.head(as))();
            if (_.isLeft(e)) {
                return e;
            }
            var out = [e.right];
            for (var i = 1; i < as.length; i++) {
                var e_1 = f(i, as[i])();
                if (_.isLeft(e_1)) {
                    return e_1;
                }
                out.push(e_1.right);
            }
            return _.right(out);
        };
    };
};
exports.traverseReadonlyNonEmptyArrayWithIndexSeq = traverseReadonlyNonEmptyArrayWithIndexSeq;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(ApplicativeSeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndexSeq = function (f) {
    var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndexSeq)(f);
    return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
};
exports.traverseReadonlyArrayWithIndexSeq = traverseReadonlyArrayWithIndexSeq;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(ApplySeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArraySeq = function (f) {
    return (0, exports.traverseReadonlyNonEmptyArrayWithIndexSeq)(function (_, a) { return f(a); });
};
exports.traverseReadonlyNonEmptyArraySeq = traverseReadonlyNonEmptyArraySeq;
/**
 * Equivalent to `ReadonlyArray#traverse(ApplicativeSeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArraySeq = function (f) {
    return (0, exports.traverseReadonlyArrayWithIndexSeq)(function (_, a) { return f(a); });
};
exports.traverseReadonlyArraySeq = traverseReadonlyArraySeq;
/**
 * Equivalent to `ReadonlyArray#sequence(ApplicativeSeq)`.
 *
 * @since 3.0.0
 */
exports.sequenceReadonlyArraySeq = 
/*#__PURE__*/ (0, exports.traverseReadonlyArraySeq)(function_1.identity);
