"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fromRefinement = exports.fromPredicate = exports.FromOption = exports.flatMapIOK = exports.fromIOK = exports.logError = exports.log = exports.FromIO = exports.partition = exports.filter = exports.Filterable = exports.Compactable = exports.Monad = exports.guard = exports.MonoidK = exports.SemigroupK = exports.tapError = exports.tap = exports.Flattenable = exports.Applicative = exports.zipRightPar = exports.zipLeftPar = exports.Apply = exports.Pointed = exports.flap = exports.Functor = exports.partitionMap = exports.filterMap = exports.separate = exports.compact = exports.none = exports.emptyK = exports.combineK = exports.flatten = exports.flatMap = exports.unit = exports.of = exports.ap = exports.map = exports.toNullable = exports.toUndefined = exports.getOrElseE = exports.getOrElse = exports.matchWithEffect = exports.match = exports.fromIOEither = exports.fromIO = exports.fromEither = exports.fromOption = exports.some = void 0;
exports.sequenceReadonlyArray = exports.traverseReadonlyArray = exports.traverseReadonlyNonEmptyArray = exports.traverseReadonlyArrayWithIndex = exports.traverseReadonlyNonEmptyArrayWithIndex = exports.ApT = exports.bindPar = exports.bind = exports.let = exports.bindTo = exports.Do = exports.flatMapEitherK = exports.fromEitherK = exports.FromEither = exports.flatMapNullableK = exports.fromNullableK = exports.fromNullable = exports.fromOptionK = void 0;
var monoidK = __importStar(require("./MonoidK"));
var apply = __importStar(require("./Apply"));
var flattenable = __importStar(require("./Flattenable"));
var compactable = __importStar(require("./Compactable"));
var filterable = __importStar(require("./Filterable"));
var fromOption_ = __importStar(require("./FromOption"));
var fromEither_ = __importStar(require("./FromEither"));
var fromIO_ = __importStar(require("./FromIO"));
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var io = __importStar(require("./IO"));
var option = __importStar(require("./Option"));
var optionT = __importStar(require("./OptionT"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
exports.some = optionT.some(io.Pointed);
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromOption = io.of;
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromEither = optionT.fromEither(io.Pointed);
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromIO = optionT.fromF(io.Functor);
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromIOEither = io.map(option.fromEither);
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @category destructors
 * @since 3.0.0
 */
exports.match = 
/*#__PURE__*/ optionT.match(io.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.matchWithEffect = optionT.matchWithEffect(io.Flattenable);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.getOrElse = optionT.getOrElse(io.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.getOrElseE = 
/*#__PURE__*/ optionT.getOrElseE(io.Monad);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.toUndefined = io.map(option.toUndefined);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.toNullable = io.map(option.toNullable);
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * Returns an effect whose success is mapped by the specified `f` function.
 *
 * @category Functor
 * @since 3.0.0
 */
exports.map = optionT.map(io.Functor);
/**
 * @category Apply
 * @since 3.0.0
 */
exports.ap = optionT.ap(io.Apply);
/**
 * @category Pointed
 * @since 3.0.0
 */
exports.of = exports.some;
/**
 * @since 3.0.0
 */
exports.unit = (0, exports.of)(undefined);
/**
 * Composes computations in sequence, using the return value of one computation to determine the next computation.
 *
 * @category Flattenable
 * @since 3.0.0
 */
exports.flatMap = 
/*#__PURE__*/ optionT.flatMap(io.Monad);
/**
 * Derivable from `Flattenable`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flatten = (0, exports.flatMap)(function_1.identity);
/**
 * @category SemigroupK
 * @since 3.0.0
 */
exports.combineK = 
/*#__PURE__*/ optionT.combineK(io.Monad);
/**
 * @category MonoidK
 * @since 3.0.0
 */
exports.emptyK = optionT.emptyK(io.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.none = (0, exports.emptyK)();
/**
 * @category Compactable
 * @since 3.0.0
 */
exports.compact = 
/*#__PURE__*/ compactable.getCompactComposition(io.Functor, option.Compactable);
/**
 * @category Compactable
 * @since 3.0.0
 */
exports.separate = 
/*#__PURE__*/ compactable.getSeparateComposition(io.Functor, option.Compactable, option.Functor);
/**
 * @category Filterable
 * @since 3.0.0
 */
exports.filterMap = 
/*#__PURE__*/ filterable.getFilterMapComposition(io.Functor, option.Filterable);
/**
 * @category Filterable
 * @since 3.0.0
 */
exports.partitionMap = filterable.getPartitionMapComposition(io.Functor, option.Filterable);
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = functor.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Pointed = {
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Apply = {
    map: exports.map,
    ap: exports.ap
};
/**
 * Returns an effect that executes both this effect and the specified effect,
 * in parallel, this effect result returned. If either side fails, then the
 * other side will **NOT** be interrupted.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.zipLeftPar = 
/*#__PURE__*/ apply.zipLeftPar(exports.Apply);
/**
 * Returns an effect that executes both this effect and the specified effect,
 * in parallel, returning result of provided effect. If either side fails,
 * then the other side will **NOT** be interrupted.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.zipRightPar = 
/*#__PURE__*/ apply.zipRightPar(exports.Apply);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Applicative = {
    map: exports.map,
    ap: exports.ap,
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Flattenable = {
    map: exports.map,
    flatMap: exports.flatMap
};
/**
 * Returns an effect that effectfully "peeks" at the success of this effect.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.tap = 
/*#__PURE__*/ flattenable.tap(exports.Flattenable);
/**
 * Returns an effect that effectfully "peeks" at the failure of this effect.
 *
 * @category combinatorsError
 * @since 3.0.0
 */
exports.tapError = 
/*#__PURE__*/ optionT.tapNone(io.Monad);
/**
 * @category instances
 * @since 3.0.0
 */
exports.SemigroupK = {
    combineK: exports.combineK
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.MonoidK = {
    combineK: exports.combineK,
    emptyK: exports.emptyK
};
/**
 * @category constructors
 * @since 3.0.0
 */
exports.guard = monoidK.guard(exports.MonoidK, exports.Pointed);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Monad = {
    map: exports.map,
    of: exports.of,
    flatMap: exports.flatMap
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Compactable = {
    compact: exports.compact,
    separate: exports.separate
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Filterable = {
    filterMap: exports.filterMap,
    partitionMap: exports.partitionMap
};
/**
 * @since 3.0.0
 */
exports.filter = filterable.filter(exports.Filterable);
/**
 * @since 3.0.0
 */
exports.partition = filterable.partition(exports.Filterable);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromIO = {
    fromIO: exports.fromIO
};
// -------------------------------------------------------------------------------------
// logging
// -------------------------------------------------------------------------------------
/**
 * @category logging
 * @since 3.0.0
 */
exports.log = fromIO_.log(exports.FromIO);
/**
 * @category logging
 * @since 3.0.0
 */
exports.logError = fromIO_.logError(exports.FromIO);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromIOK = 
/*#__PURE__*/ fromIO_.fromIOK(exports.FromIO);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flatMapIOK = 
/*#__PURE__*/ fromIO_.flatMapIOK(exports.FromIO, exports.Flattenable);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromOption = {
    fromOption: exports.fromOption
};
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromPredicate = 
/*#__PURE__*/ fromOption_.fromPredicate(exports.FromOption);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromRefinement = 
/*#__PURE__*/ fromOption_.fromRefinement(exports.FromOption);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromOptionK = 
/*#__PURE__*/ fromOption_.fromOptionK(exports.FromOption);
// -------------------------------------------------------------------------------------
// interop
// -------------------------------------------------------------------------------------
/**
 * @category interop
 * @since 3.0.0
 */
exports.fromNullable = fromOption_.fromNullable(exports.FromOption);
/**
 * @category interop
 * @since 3.0.0
 */
exports.fromNullableK = fromOption_.fromNullableK(exports.FromOption);
/**
 * @category interop
 * @since 3.0.0
 */
exports.flatMapNullableK = fromOption_.flatMapNullableK(exports.FromOption, exports.Flattenable);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromEither = {
    fromEither: exports.fromEither
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromEitherK = fromEither_.fromEitherK(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flatMapEitherK = 
/*#__PURE__*/ fromEither_.flatMapEitherK(exports.FromEither, exports.Flattenable);
// -------------------------------------------------------------------------------------
// do notation
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.Do = (0, exports.of)(_.emptyRecord);
/**
 * @since 3.0.0
 */
exports.bindTo = 
/*#__PURE__*/ functor.bindTo(exports.Functor);
var let_ = 
/*#__PURE__*/ functor.let(exports.Functor);
exports.let = let_;
/**
 * @since 3.0.0
 */
exports.bind = 
/*#__PURE__*/ flattenable.bind(exports.Flattenable);
/**
 * @since 3.0.0
 */
exports.bindPar = 
/*#__PURE__*/ apply.bindPar(exports.Apply);
// -------------------------------------------------------------------------------------
// sequence T
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.ApT = (0, exports.of)(_.emptyReadonlyArray);
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(Apply)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndex = function (f) {
    return (0, function_1.flow)(io.traverseReadonlyNonEmptyArrayWithIndex(f), io.map(option.traverseReadonlyNonEmptyArrayWithIndex(function_1.SK)));
};
exports.traverseReadonlyNonEmptyArrayWithIndex = traverseReadonlyNonEmptyArrayWithIndex;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(Applicative)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndex = function (f) {
    var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(f);
    return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
};
exports.traverseReadonlyArrayWithIndex = traverseReadonlyArrayWithIndex;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(Apply)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArray = function (f) {
    return (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(function (_, a) { return f(a); });
};
exports.traverseReadonlyNonEmptyArray = traverseReadonlyNonEmptyArray;
/**
 * Equivalent to `ReadonlyArray#traverse(Applicative)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArray = function (f) {
    return (0, exports.traverseReadonlyArrayWithIndex)(function (_, a) { return f(a); });
};
exports.traverseReadonlyArray = traverseReadonlyArray;
/**
 * Equivalent to `ReadonlyArray#sequence(Applicative)`.
 *
 * @since 3.0.0
 */
exports.sequenceReadonlyArray = 
/*#__PURE__*/ (0, exports.traverseReadonlyArray)(function_1.identity);
