"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.apT = exports.tupled = exports.ApT = exports.bindPar = exports.bind = exports.let = exports.bindTo = exports.Do = exports.SemigroupK = exports.combineK = exports.sequence = exports.Traversable = exports.traverse = exports.Foldable = exports.reduceRight = exports.foldMap = exports.reduce = exports.Comonad = exports.extract = exports.Extendable = exports.duplicate = exports.extend = exports.Monad = exports.FlattenableRec = exports.flatMapRec = exports.flatten = exports.Flattenable = exports.flatMap = exports.Applicative = exports.zipRightPar = exports.zipLeftPar = exports.Apply = exports.ap = exports.Pointed = exports.unit = exports.of = exports.flap = exports.Functor = exports.map = exports.getEq = exports.getShow = void 0;
var apply = __importStar(require("./Apply"));
var flattenable = __importStar(require("./Flattenable"));
var flattenableRec = __importStar(require("./FlattenableRec"));
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var traversable = __importStar(require("./Traversable"));
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
exports.getShow = function_1.identity;
/**
 * @category instances
 * @since 3.0.0
 */
exports.getEq = function_1.identity;
/**
 * @category combinators
 * @since 3.0.0
 */
exports.map = function_1.identity;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * @since 3.0.0
 */
exports.flap = functor.flap(exports.Functor);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.of = function_1.identity;
/**
 * @since 3.0.0
 */
exports.unit = (0, exports.of)(undefined);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Pointed = {
    of: exports.of
};
/**
 * @category combinators
 * @since 3.0.0
 */
var ap = function (fa) { return function (fab) { return fab(fa); }; };
exports.ap = ap;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Apply = {
    map: exports.map,
    ap: exports.ap
};
/**
 * Combine two effectful actions, keeping only the result of the first.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.zipLeftPar = 
/*#__PURE__*/ apply.zipLeftPar(exports.Apply);
/**
 * Combine two effectful actions, keeping only the result of the second.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.zipRightPar = 
/*#__PURE__*/ apply.zipRightPar(exports.Apply);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Applicative = {
    map: exports.map,
    ap: exports.ap,
    of: exports.of
};
/**
 * Composes computations in sequence, using the return value of one computation to determine the next computation.
 *
 * @category combinators
 * @since 3.0.0
 */
var flatMap = function (f) { return function (ma) { return f(ma); }; };
exports.flatMap = flatMap;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Flattenable = {
    map: exports.map,
    flatMap: exports.flatMap
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flatten = (0, exports.flatMap)(function_1.identity);
/**
 * @since 3.0.0
 */
exports.flatMapRec = flattenableRec.tailRec;
/**
 * @category instances
 * @since 3.0.0
 */
exports.FlattenableRec = {
    flatMapRec: exports.flatMapRec
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Monad = {
    map: exports.map,
    of: exports.of,
    flatMap: exports.flatMap
};
/**
 * @category combinators
 * @since 3.0.0
 */
var extend = function (f) { return function (wa) { return f(wa); }; };
exports.extend = extend;
/**
 * @category combinators
 * @since 3.0.0
 */
exports.duplicate = (0, exports.extend)(function_1.identity);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Extendable = {
    map: exports.map,
    extend: exports.extend
};
/**
 * @since 3.0.0
 */
exports.extract = function_1.identity;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Comonad = {
    map: exports.map,
    extend: exports.extend,
    extract: exports.extract
};
/**
 * @since 3.0.0
 */
var reduce = function (b, f) { return function (fa) { return f(b, fa); }; };
exports.reduce = reduce;
/**
 * @since 3.0.0
 */
var foldMap = function () { return function (f) { return function (fa) { return f(fa); }; }; };
exports.foldMap = foldMap;
/**
 * @since 3.0.0
 */
var reduceRight = function (b, f) { return function (fa) { return f(fa, b); }; };
exports.reduceRight = reduceRight;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Foldable = {
    reduce: exports.reduce,
    foldMap: exports.foldMap,
    reduceRight: exports.reduceRight
};
/**
 * @category combinators
 * @since 3.0.0
 */
var traverse = function (F) { return function (f) {
    return (0, function_1.flow)(f, F.map(function_1.identity));
}; };
exports.traverse = traverse;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Traversable = {
    traverse: exports.traverse
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.sequence = 
/*#__PURE__*/ traversable.getDefaultSequence(exports.traverse);
/**
 * @category combinators
 * @since 3.0.0
 */
var combineK = function () { return function_1.identity; };
exports.combineK = combineK;
/**
 * @category instances
 * @since 3.0.0
 */
exports.SemigroupK = {
    combineK: exports.combineK
};
// -------------------------------------------------------------------------------------
// do notation
// -------------------------------------------------------------------------------------
/**
 * @category do notation
 * @since 3.0.0
 */
exports.Do = (0, exports.of)(_.emptyRecord);
/**
 * @category do notation
 * @since 3.0.0
 */
exports.bindTo = 
/*#__PURE__*/ functor.bindTo(exports.Functor);
var let_ = /*#__PURE__*/ functor.let(exports.Functor);
exports.let = let_;
/**
 * @category do notation
 * @since 3.0.0
 */
exports.bind = 
/*#__PURE__*/ flattenable.bind(exports.Flattenable);
/**
 * @category do notation
 * @since 3.0.0
 */
exports.bindPar = 
/*#__PURE__*/ apply.bindPar(exports.Apply);
/**
 * @category do notation
 * @since 3.0.0
 */
exports.ApT = (0, exports.of)(_.emptyReadonlyArray);
/**
 * @category do notation
 * @since 3.0.0
 */
exports.tupled = functor.tupled(exports.Functor);
/**
 * @category do notation
 * @since 3.0.0
 */
exports.apT = 
/*#__PURE__*/ apply.apT(exports.Apply);
