"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.emptyK = exports.combineK = exports.flatMap = exports.ap = exports.map = exports.tapNone = exports.getOrElseE = exports.getOrElse = exports.matchWithEffect = exports.match = exports.fromEither = exports.fromF = exports.some = void 0;
/**
 * @since 3.0.0
 */
var apply = __importStar(require("./Apply"));
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var option = __importStar(require("./Option"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
var some = function (F) {
    return function (a) {
        return F.of(_.some(a));
    };
};
exports.some = some;
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 3.0.0
 */
function fromF(F) {
    return F.map(_.some);
}
exports.fromF = fromF;
/**
 * @category natural transformations
 * @since 3.0.0
 */
var fromEither = function (F) {
    return function (e) {
        return F.of(option.fromEither(e));
    };
};
exports.fromEither = fromEither;
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function match(F) {
    return (0, function_1.flow)(option.match, F.map);
}
exports.match = match;
/**
 * @since 3.0.0
 */
var matchWithEffect = function (M) {
    return function (onNone, onSome) {
        return M.flatMap(option.match(onNone, onSome));
    };
};
exports.matchWithEffect = matchWithEffect;
/**
 * @since 3.0.0
 */
var getOrElse = function (F) {
    return function (onNone) {
        return F.map(option.getOrElse(onNone));
    };
};
exports.getOrElse = getOrElse;
/**
 * @since 3.0.0
 */
var getOrElseE = function (M) {
    return function (onNone) {
        return function (self) {
            return (0, function_1.pipe)(self, M.flatMap(option.match(onNone, M.of)));
        };
    };
};
exports.getOrElseE = getOrElseE;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * Returns an effect that effectfully "peeks" at the failure of this effect.
 *
 * @category combinatorsError
 * @since 3.0.0
 */
var tapNone = function (M) {
    var someM = (0, exports.some)(M);
    return function (onNone) {
        return function (self) {
            return (0, function_1.pipe)(self, M.flatMap(option.match((0, function_1.flow)(onNone, M.map(function () { return _.none; })), someM)));
        };
    };
};
exports.tapNone = tapNone;
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function map(F) {
    return functor.getMapComposition(F, option.Functor);
}
exports.map = map;
/**
 * @since 3.0.0
 */
var ap = function (F) {
    return apply.getApComposition(F, option.Apply);
};
exports.ap = ap;
/**
 * @since 3.0.0
 */
var flatMap = function (M) {
    return function (f) {
        return function (self) {
            return (0, function_1.pipe)(self, M.flatMap(option.match(function () { return emptyK(M)(); }, f)));
        };
    };
};
exports.flatMap = flatMap;
/**
 * @since 3.0.0
 */
var combineK = function (M) {
    var someM = (0, exports.some)(M);
    return function (second) {
        return function (self) {
            return (0, function_1.pipe)(self, M.flatMap(option.match(second, someM)));
        };
    };
};
exports.combineK = combineK;
/**
 * @since 3.0.0
 */
function emptyK(F) {
    return (0, function_1.constant)(F.of(_.none));
}
exports.emptyK = emptyK;
