"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.flatMapOptionK = exports.fromOptionK = exports.fromOption = exports.FromEither = exports.flatMapReaderK = exports.fromReaderK = exports.asks = exports.ask = exports.FromReader = exports.SemigroupK = exports.Bifunctor = exports.tapError = exports.tap = exports.Monad = exports.Flattenable = exports.Applicative = exports.zipRightPar = exports.zipLeftPar = exports.Apply = exports.Pointed = exports.flap = exports.Functor = exports.getFilterable = exports.getCompactable = exports.getValidatedSemigroupK = exports.getValidatedApplicative = exports.combineK = exports.flatten = exports.flatMap = exports.unit = exports.of = exports.ap = exports.mapError = exports.mapBoth = exports.map = exports.swap = exports.orElse = exports.local = exports.toUnion = exports.getOrElseE = exports.getOrElse = exports.matchWithEffect = exports.match = exports.fromReader = exports.fromEither = exports.asksReaderEither = exports.leftReader = exports.rightReader = exports.right = exports.left = void 0;
exports.sequenceReadonlyArray = exports.traverseReadonlyArray = exports.traverseReadonlyNonEmptyArray = exports.traverseReadonlyArrayWithIndex = exports.traverseReadonlyNonEmptyArrayWithIndex = exports.bracket = exports.apT = exports.tupled = exports.ApT = exports.bindPar = exports.bind = exports.let = exports.bindTo = exports.Do = exports.flatMapNullableK = exports.fromNullableK = exports.fromNullable = exports.flatMapEitherK = exports.fromEitherK = exports.partitionMap = exports.partition = exports.filterMap = exports.filter = exports.fromPredicate = void 0;
var apply = __importStar(require("./Apply"));
var flattenable = __importStar(require("./Flattenable"));
var compactable = __importStar(require("./Compactable"));
var either = __importStar(require("./Either"));
var eitherT = __importStar(require("./EitherT"));
var fromEither_ = __importStar(require("./FromEither"));
var fromReader_ = __importStar(require("./FromReader"));
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var reader = __importStar(require("./Reader"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
exports.left = eitherT.left(reader.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.right = eitherT.right(reader.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.rightReader = eitherT.rightF(reader.Functor);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.leftReader = eitherT.leftF(reader.Functor);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.asksReaderEither = reader.asksReader;
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromEither = reader.of;
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromReader = exports.rightReader;
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @category destructors
 * @since 3.0.0
 */
exports.match = eitherT.match(reader.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.matchWithEffect = eitherT.matchWithEffect(reader.Monad);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.getOrElse = 
/*#__PURE__*/ eitherT.getOrElse(reader.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.getOrElseE = eitherT.getOrElseE(reader.Monad);
// -------------------------------------------------------------------------------------
// interop
// -------------------------------------------------------------------------------------
/**
 * @category interop
 * @since 3.0.0
 */
exports.toUnion = eitherT.toUnion(reader.Functor);
/**
 * Changes the value of the local context during the execution of the action `ma` (similar to `Contravariant`'s
 * `contramap`).
 *
 * @category combinators
 * @since 3.0.0
 */
exports.local = reader.local;
/**
 * @category combinators
 * @since 3.0.0
 */
exports.orElse = eitherT.orElse(reader.Monad);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.swap = eitherT.swap(reader.Functor);
/**
 * Returns an effect whose success is mapped by the specified `f` function.
 *
 * @category Functor
 * @since 3.0.0
 */
exports.map = 
/*#__PURE__*/ eitherT.map(reader.Functor);
/**
 * Returns an effect whose failure and success channels have been mapped by
 * the specified pair of functions, `f` and `g`.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.mapBoth = eitherT.mapBoth(reader.Functor);
/**
 * Returns an effect with its error channel mapped using the specified
 * function. This can be used to lift a "smaller" error into a "larger" error.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.mapError = 
/*#__PURE__*/ eitherT.mapLeft(reader.Functor);
/**
 * Apply a function to an argument under a type constructor.
 *
 * @category Apply
 * @since 3.0.0
 */
exports.ap = 
/*#__PURE__*/ eitherT.ap(reader.Apply);
/**
 * @category Pointed
 * @since 3.0.0
 */
exports.of = exports.right;
/**
 * @since 3.0.0
 */
exports.unit = (0, exports.of)(undefined);
/**
 * Composes computations in sequence, using the return value of one computation to determine the next computation.
 *
 * @category Flattenable
 * @since 3.0.0
 */
exports.flatMap = eitherT.flatMap(reader.Monad);
/**
 * Derivable from `Flattenable`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flatten = (0, exports.flatMap)(function_1.identity);
/**
 * Identifies an associative operation on a type constructor. It is similar to `Semigroup`, except that it applies to
 * types of kind `* -> *`.
 *
 * @category SemigroupK
 * @since 3.0.0
 */
exports.combineK = eitherT.combineK(reader.Monad);
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * The default [`Applicative`](#applicative) instance returns the first error, if you want to
 * get all errors you need to provide an way to combine them via a `Semigroup`.
 *
 * See [`getValidatedApplicative`](./Either.ts.html#getvalidatedapplicative).
 *
 * @category instances
 * @since 3.0.0
 */
var getValidatedApplicative = function (S) { return ({
    map: exports.map,
    ap: apply.getApComposition(reader.Apply, either.getValidatedApplicative(S)),
    of: exports.of
}); };
exports.getValidatedApplicative = getValidatedApplicative;
/**
 * The default [`SemigroupK`](#semigroupk) instance returns the last error, if you want to
 * get all errors you need to provide an way to combine them via a `Semigroup`.
 *
 * @category instances
 * @since 3.0.0
 */
var getValidatedSemigroupK = function (S) {
    return {
        combineK: eitherT.getValidatedCombineK(reader.Monad, S)
    };
};
exports.getValidatedSemigroupK = getValidatedSemigroupK;
/**
 * @category instances
 * @since 3.0.0
 */
var getCompactable = function (M) {
    var C = either.getCompactable(M);
    var F = { map: either.map };
    return {
        compact: compactable.getCompactComposition(reader.Functor, C),
        separate: compactable.getSeparateComposition(reader.Functor, C, F)
    };
};
exports.getCompactable = getCompactable;
/**
 * @category instances
 * @since 3.0.0
 */
var getFilterable = function (M) {
    return {
        partitionMap: function (f) { return (0, exports.partitionMap)(f, function () { return M.empty; }); },
        filterMap: function (f) { return (0, exports.filterMap)(f, function () { return M.empty; }); }
    };
};
exports.getFilterable = getFilterable;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/ functor.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Pointed = {
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Apply = {
    map: exports.map,
    ap: exports.ap
};
/**
 * Combine two effectful actions, keeping only the result of the first.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.zipLeftPar = 
/*#__PURE__*/ apply.zipLeftPar(exports.Apply);
/**
 * Combine two effectful actions, keeping only the result of the second.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.zipRightPar = 
/*#__PURE__*/ apply.zipRightPar(exports.Apply);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Applicative = {
    map: exports.map,
    ap: exports.ap,
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Flattenable = {
    map: exports.map,
    flatMap: exports.flatMap
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Monad = {
    map: exports.map,
    of: exports.of,
    flatMap: exports.flatMap
};
/**
 * Returns an effect that effectfully "peeks" at the success of this effect.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.tap = 
/*#__PURE__*/ flattenable.tap(exports.Flattenable);
/**
 * Returns an effect that effectfully "peeks" at the failure of this effect.
 *
 * @category combinatorsError
 * @since 3.0.0
 */
exports.tapError = eitherT.tapLeft(reader.Monad);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    mapBoth: exports.mapBoth
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.SemigroupK = {
    combineK: exports.combineK
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromReader = {
    fromReader: exports.fromReader
};
/**
 * Reads the current context.
 *
 * @category constructors
 * @since 3.0.0
 */
exports.ask = fromReader_.ask(exports.FromReader);
/**
 * Projects a value from the global context in a `ReaderEither`.
 *
 * @category constructors
 * @since 3.0.0
 */
exports.asks = fromReader_.asks(exports.FromReader);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromReaderK = fromReader_.fromReaderK(exports.FromReader);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flatMapReaderK = fromReader_.flatMapReaderK(exports.FromReader, exports.Flattenable);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromEither = {
    fromEither: exports.fromEither
};
/**
 * Derivable from `FromEither`.
 *
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromOption = 
/*#__PURE__*/ fromEither_.fromOption(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromOptionK = fromEither_.fromOptionK(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flatMapOptionK = fromEither_.flatMapOptionK(exports.FromEither, exports.Flattenable);
/**
 * Derivable from `FromEither`.
 *
 * @category constructors
 * @since 3.0.0
 */
exports.fromPredicate = fromEither_.fromPredicate(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.filter = fromEither_.filter(exports.FromEither, exports.Flattenable);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.filterMap = fromEither_.filterMap(exports.FromEither, exports.Flattenable);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.partition = fromEither_.partition(exports.FromEither, exports.Flattenable);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.partitionMap = 
/*#__PURE__*/ fromEither_.partitionMap(exports.FromEither, exports.Flattenable);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromEitherK = fromEither_.fromEitherK(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flatMapEitherK = fromEither_.flatMapEitherK(exports.FromEither, exports.Flattenable);
/**
 * @category interop
 * @since 3.0.0
 */
exports.fromNullable = 
/*#__PURE__*/ fromEither_.fromNullable(exports.FromEither);
/**
 * @category interop
 * @since 3.0.0
 */
exports.fromNullableK = fromEither_.fromNullableK(exports.FromEither);
/**
 * @category interop
 * @since 3.0.0
 */
exports.flatMapNullableK = 
/*#__PURE__*/ fromEither_.flatMapNullableK(exports.FromEither, exports.Flattenable);
// -------------------------------------------------------------------------------------
// do notation
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.Do = (0, exports.of)(_.emptyRecord);
/**
 * @since 3.0.0
 */
exports.bindTo = 
/*#__PURE__*/ functor.bindTo(exports.Functor);
var let_ = 
/*#__PURE__*/ functor.let(exports.Functor);
exports.let = let_;
/**
 * @since 3.0.0
 */
exports.bind = 
/*#__PURE__*/ flattenable.bind(exports.Flattenable);
/**
 * @since 3.0.0
 */
exports.bindPar = 
/*#__PURE__*/ apply.bindPar(exports.Apply);
// -------------------------------------------------------------------------------------
// sequence T
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.ApT = (0, exports.of)(_.emptyReadonlyArray);
/**
 * @since 3.0.0
 */
exports.tupled = 
/*#__PURE__*/ functor.tupled(exports.Functor);
/**
 * @since 3.0.0
 */
exports.apT = apply.apT(exports.Apply);
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * Make sure that a resource is cleaned up in the event of an exception (\*). The release action is called regardless of
 * whether the body action throws (\*) or returns.
 *
 * (\*) i.e. returns a `Left`
 *
 * @since 3.0.0
 */
exports.bracket = eitherT.bracket(reader.Monad);
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(Apply)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndex = function (f) {
    return (0, function_1.flow)(reader.traverseReadonlyNonEmptyArrayWithIndex(f), reader.map(either.traverseReadonlyNonEmptyArrayWithIndex(function_1.SK)));
};
exports.traverseReadonlyNonEmptyArrayWithIndex = traverseReadonlyNonEmptyArrayWithIndex;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(Applicative)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndex = function (f) {
    var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(f);
    return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
};
exports.traverseReadonlyArrayWithIndex = traverseReadonlyArrayWithIndex;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(Apply)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArray = function (f) {
    return (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(function (_, a) { return f(a); });
};
exports.traverseReadonlyNonEmptyArray = traverseReadonlyNonEmptyArray;
/**
 * Equivalent to `ReadonlyArray#traverse(Applicative)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArray = function (f) {
    return (0, exports.traverseReadonlyArrayWithIndex)(function (_, a) { return f(a); });
};
exports.traverseReadonlyArray = traverseReadonlyArray;
/**
 * Equivalent to `ReadonlyArray#sequence(Applicative)`.
 *
 * @since 3.0.0
 */
exports.sequenceReadonlyArray = (0, exports.traverseReadonlyArray)(function_1.identity);
