"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fromReader = exports.flatMap = exports.ap = exports.map = exports.of = void 0;
var function_1 = require("./function");
/**
 * @since 3.0.0
 */
function of(F) {
    return function (a) { return function () { return F.of(a); }; };
}
exports.of = of;
/**
 * @since 3.0.0
 */
function map(F) {
    return function (f) { return function (fa) { return (0, function_1.flow)(fa, F.map(f)); }; };
}
exports.map = map;
/**
 * @since 3.0.0
 */
var ap = function (F) {
    return function (fa) { return function (fab) { return function (r) { return F.ap(fa(r))(fab(r)); }; }; };
};
exports.ap = ap;
/**
 * @since 3.0.0
 */
var flatMap = function (M) {
    return function (f) {
        return function (ma) {
            return function (r) {
                return (0, function_1.pipe)(ma(r), M.flatMap(function (a) { return f(a)(r); }));
            };
        };
    };
};
exports.flatMap = flatMap;
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
var fromReader = function (F) {
    return function (ma) {
        return function (r) { return F.of(ma(r)); };
    };
};
exports.fromReader = fromReader;
