"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.traverseReadonlyNonEmptyArray = exports.traverseReadonlyArrayWithIndex = exports.traverseReadonlyNonEmptyArrayWithIndex = exports.apT = exports.tupled = exports.ApT = exports.bindPar = exports.bind = exports.let = exports.bindTo = exports.Do = exports.flatMapTaskK = exports.fromTaskK = exports.FromTask = exports.flatMapReaderK = exports.fromReaderK = exports.asks = exports.ask = exports.FromReader = exports.flatMapIOK = exports.fromIOK = exports.logError = exports.log = exports.FromIO = exports.Monad = exports.tap = exports.ApplicativeSeq = exports.ApplySeq = exports.Flattenable = exports.ApplicativePar = exports.zipRightPar = exports.zipLeftPar = exports.ApplyPar = exports.Pointed = exports.flap = exports.Functor = exports.flatMapReaderIOK = exports.fromReaderIOK = exports.flatten = exports.flatMap = exports.unit = exports.of = exports.ap = exports.map = exports.local = exports.fromReaderIO = exports.fromIO = exports.fromTask = exports.fromReader = exports.asksReaderTask = void 0;
exports.sequenceReadonlyArraySeq = exports.traverseReadonlyArraySeq = exports.traverseReadonlyNonEmptyArraySeq = exports.traverseReadonlyArrayWithIndexSeq = exports.traverseReadonlyNonEmptyArrayWithIndexSeq = exports.sequenceReadonlyArray = exports.traverseReadonlyArray = void 0;
var apply = __importStar(require("./Apply"));
var flattenable = __importStar(require("./Flattenable"));
var fromIO_ = __importStar(require("./FromIO"));
var fromReader_ = __importStar(require("./FromReader"));
var fromTask_ = __importStar(require("./FromTask"));
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var reader = __importStar(require("./Reader"));
var readerT = __importStar(require("./ReaderT"));
var task = __importStar(require("./Task"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
exports.asksReaderTask = reader.asksReader;
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromReader = readerT.fromReader(task.Pointed);
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromTask = reader.of;
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromIO = (0, function_1.flow)(task.fromIO, exports.fromTask);
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromReaderIO = reader.map(task.fromIO);
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * Changes the value of the local context during the execution of the action `ma` (similar to `Contravariant`'s
 * `contramap`).
 *
 * @category combinators
 * @since 3.0.0
 */
exports.local = reader.local;
/**
 * @category Functor
 * @since 3.0.0
 */
exports.map = readerT.map(task.Functor);
/**
 * Apply a function to an argument under a type constructor.
 *
 * @category Apply
 * @since 3.0.0
 */
exports.ap = 
/*#__PURE__*/ readerT.ap(task.ApplyPar);
/**
 * @category Pointed
 * @since 3.0.0
 */
exports.of = readerT.of(task.Pointed);
/**
 * @since 3.0.0
 */
exports.unit = (0, exports.of)(undefined);
/**
 * Composes computations in sequence, using the return value of one computation to determine the next computation.
 *
 * @category Flattenable
 * @since 3.0.0
 */
exports.flatMap = readerT.flatMap(task.Monad);
/**
 * Derivable from `Flattenable`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flatten = 
/*#__PURE__*/ (0, exports.flatMap)(function_1.identity);
/**
 * @category combinators
 * @since 3.0.0
 */
var fromReaderIOK = function (f) {
    return function () {
        var a = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            a[_i] = arguments[_i];
        }
        return (0, exports.fromReaderIO)(f.apply(void 0, a));
    };
};
exports.fromReaderIOK = fromReaderIOK;
/**
 * @category combinators
 * @since 3.0.0
 */
var flatMapReaderIOK = function (f) { return (0, exports.flatMap)((0, exports.fromReaderIOK)(f)); };
exports.flatMapReaderIOK = flatMapReaderIOK;
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/ functor.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Pointed = {
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplyPar = {
    map: exports.map,
    ap: exports.ap
};
/**
 * Combine two effectful actions, keeping only the result of the first.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.zipLeftPar = 
/*#__PURE__*/ apply.zipLeftPar(exports.ApplyPar);
/**
 * Combine two effectful actions, keeping only the result of the second.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.zipRightPar = 
/*#__PURE__*/ apply.zipRightPar(exports.ApplyPar);
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplicativePar = {
    map: exports.map,
    ap: exports.ap,
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Flattenable = {
    map: exports.map,
    flatMap: exports.flatMap
};
var apSeq = /*#__PURE__*/ flattenable.ap(exports.Flattenable);
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplySeq = {
    map: exports.map,
    ap: apSeq
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.ApplicativeSeq = {
    map: exports.map,
    ap: apSeq,
    of: exports.of
};
/**
 * Returns an effect that effectfully "peeks" at the success of this effect.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.tap = 
/*#__PURE__*/ flattenable.tap(exports.Flattenable);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Monad = {
    map: exports.map,
    of: exports.of,
    flatMap: exports.flatMap
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromIO = {
    fromIO: exports.fromIO
};
// -------------------------------------------------------------------------------------
// logging
// -------------------------------------------------------------------------------------
/**
 * @category logging
 * @since 3.0.0
 */
exports.log = fromIO_.log(exports.FromIO);
/**
 * @category logging
 * @since 3.0.0
 */
exports.logError = 
/*#__PURE__*/ fromIO_.logError(exports.FromIO);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromIOK = fromIO_.fromIOK(exports.FromIO);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flatMapIOK = 
/*#__PURE__*/ fromIO_.flatMapIOK(exports.FromIO, exports.Flattenable);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromReader = {
    fromReader: exports.fromReader
};
/**
 * Reads the current context.
 *
 * @category constructors
 * @since 3.0.0
 */
exports.ask = fromReader_.ask(exports.FromReader);
/**
 * Projects a value from the global context in a `ReaderTask`.
 *
 * @category constructors
 * @since 3.0.0
 */
exports.asks = fromReader_.asks(exports.FromReader);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromReaderK = fromReader_.fromReaderK(exports.FromReader);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flatMapReaderK = fromReader_.flatMapReaderK(exports.FromReader, exports.Flattenable);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromTask = {
    fromIO: exports.fromIO,
    fromTask: exports.fromTask
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromTaskK = fromTask_.fromTaskK(exports.FromTask);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flatMapTaskK = 
/*#__PURE__*/ fromTask_.flatMapTaskK(exports.FromTask, exports.Flattenable);
// -------------------------------------------------------------------------------------
// do notation
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.Do = (0, exports.of)(_.emptyRecord);
/**
 * @since 3.0.0
 */
exports.bindTo = functor.bindTo(exports.Functor);
var let_ = 
/*#__PURE__*/ functor.let(exports.Functor);
exports.let = let_;
/**
 * @since 3.0.0
 */
exports.bind = 
/*#__PURE__*/ flattenable.bind(exports.Flattenable);
/**
 * @since 3.0.0
 */
exports.bindPar = 
/*#__PURE__*/ apply.bindPar(exports.ApplyPar);
// -------------------------------------------------------------------------------------
// sequence T
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.ApT = (0, exports.of)(_.emptyReadonlyArray);
/**
 * @since 3.0.0
 */
exports.tupled = functor.tupled(exports.Functor);
/**
 * @since 3.0.0
 */
exports.apT = 
/*#__PURE__*/ apply.apT(exports.ApplyPar);
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
// --- Par ---
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(ApplyPar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndex = function (f) {
    return (0, function_1.flow)(reader.traverseReadonlyNonEmptyArrayWithIndex(f), reader.map(task.traverseReadonlyNonEmptyArrayWithIndex(function_1.SK)));
};
exports.traverseReadonlyNonEmptyArrayWithIndex = traverseReadonlyNonEmptyArrayWithIndex;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(ApplicativePar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndex = function (f) {
    var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(f);
    return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
};
exports.traverseReadonlyArrayWithIndex = traverseReadonlyArrayWithIndex;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(ApplyPar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArray = function (f) {
    return (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(function (_, a) { return f(a); });
};
exports.traverseReadonlyNonEmptyArray = traverseReadonlyNonEmptyArray;
/**
 * Equivalent to `ReadonlyArray#traverse(ApplicativePar)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArray = function (f) {
    return (0, exports.traverseReadonlyArrayWithIndex)(function (_, a) { return f(a); });
};
exports.traverseReadonlyArray = traverseReadonlyArray;
/**
 * Equivalent to `ReadonlyArray#sequence(ApplicativePar)`.
 *
 * @since 3.0.0
 */
exports.sequenceReadonlyArray = 
/*#__PURE__*/ (0, exports.traverseReadonlyArray)(function_1.identity);
// --- Seq ---
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(ApplySeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndexSeq = function (f) {
    return (0, function_1.flow)(reader.traverseReadonlyNonEmptyArrayWithIndex(f), reader.map(task.traverseReadonlyNonEmptyArrayWithIndexSeq(function_1.SK)));
};
exports.traverseReadonlyNonEmptyArrayWithIndexSeq = traverseReadonlyNonEmptyArrayWithIndexSeq;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(ApplicativeSeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndexSeq = function (f) {
    var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndexSeq)(f);
    return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
};
exports.traverseReadonlyArrayWithIndexSeq = traverseReadonlyArrayWithIndexSeq;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(ApplySeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArraySeq = function (f) {
    return (0, exports.traverseReadonlyNonEmptyArrayWithIndexSeq)(function (_, a) { return f(a); });
};
exports.traverseReadonlyNonEmptyArraySeq = traverseReadonlyNonEmptyArraySeq;
/**
 * Equivalent to `ReadonlyArray#traverse(ApplicativeSeq)`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArraySeq = function (f) {
    return (0, exports.traverseReadonlyArrayWithIndexSeq)(function (_, a) { return f(a); });
};
exports.traverseReadonlyArraySeq = traverseReadonlyArraySeq;
/**
 * Equivalent to `ReadonlyArray#sequence(ApplicativeSeq)`.
 *
 * @since 3.0.0
 */
exports.sequenceReadonlyArraySeq = 
/*#__PURE__*/ (0, exports.traverseReadonlyArraySeq)(function_1.identity);
