"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sequenceReadonlyArray = exports.traverseReadonlyArray = exports.traverseReadonlyNonEmptyArray = exports.traverseReadonlyArrayWithIndex = exports.traverseReadonlyNonEmptyArrayWithIndex = exports.tupled = exports.let = exports.bindTo = exports.getFromTask = exports.getFromIO = exports.getFromReader = exports.fromWriterK = exports.FromWriter = exports.getMonad = exports.getFlattenable = exports.getApplicative = exports.getApply = exports.getPointed = exports.flap = exports.Functor = exports.Bifunctor = exports.mapBoth = exports.mapError = exports.map = exports.censor = exports.listens = exports.pass = exports.listen = exports.fromReaderWriterK = exports.fromTaskWriterK = exports.swap = exports.local = exports.execute = exports.evaluate = exports.snd = exports.fst = exports.fromReaderWriter = exports.fromWriter = exports.asksReaderTaskWriter = exports.tell = exports.fromTask = exports.fromIO = exports.fromTaskWriter = exports.fromReaderTask = exports.fromReader = void 0;
var fromWriter_ = __importStar(require("./FromWriter"));
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var reader = __importStar(require("./Reader"));
var readerTask = __importStar(require("./ReaderTask"));
var readonlyNonEmptyArray = __importStar(require("./ReadonlyNonEmptyArray"));
var task = __importStar(require("./Task"));
var writerT = __importStar(require("./WriterT"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
var fromReader = function (w) {
    return function (fa) {
        return (0, exports.fromReaderTask)(w)(readerTask.fromReader(fa));
    };
};
exports.fromReader = fromReader;
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromReaderTask = 
/*#__PURE__*/ writerT.fromF(readerTask.Functor);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromTaskWriter = reader.of;
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromIO = writerT.fromIO(readerTask.Functor, readerTask.FromIO);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromTask = 
/*#__PURE__*/ writerT.fromTask(readerTask.Functor, readerTask.FromTask);
/**
 * Appends a value to the accumulator
 *
 * @category constructors
 * @since 3.0.0
 */
exports.tell = writerT.tell(readerTask.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.asksReaderTaskWriter = reader.asksReader;
// -------------------------------------------------------------------------------------
// natural transformations
// -------------------------------------------------------------------------------------
/**
 * @category natural transformations
 * @since 3.0.0
 */
var fromWriter = function (fa) { return readerTask.of(fa); };
exports.fromWriter = fromWriter;
/**
 * @category natural transformations
 * @since 3.0.0
 */
var fromReaderWriter = function (fa) { return (0, function_1.flow)(fa, task.of); };
exports.fromReaderWriter = fromReaderWriter;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.fst = writerT.fst(readerTask.Functor);
/**
 * @since 3.0.0
 */
exports.snd = writerT.snd(readerTask.Functor);
/**
 * Alias of [`fst`](#fst).
 *
 * @since 3.0.0
 */
exports.evaluate = exports.fst;
/**
 * Alias of [`snd`](#snd).
 *
 * @since 3.0.0
 */
exports.execute = exports.snd;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * Changes the value of the local context during the execution of the action `ma` (similar to `Contravariant`'s
 * `contramap`).
 *
 * @category combinators
 * @since 3.0.0
 */
exports.local = reader.local;
/**
 * @since 3.0.0
 */
exports.swap = writerT.swap(readerTask.Functor);
/**
 * @category combinators
 * @since 3.0.0
 */
var fromTaskWriterK = function (f) {
    return function () {
        var a = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            a[_i] = arguments[_i];
        }
        return (0, exports.fromTaskWriter)(f.apply(void 0, a));
    };
};
exports.fromTaskWriterK = fromTaskWriterK;
/**
 * @category combinators
 * @since 3.0.0
 */
var fromReaderWriterK = function (f) { return (0, function_1.flow)(f, exports.fromReaderWriter); };
exports.fromReaderWriterK = fromReaderWriterK;
/**
 * @since 3.0.0
 */
exports.listen = 
/*#__PURE__*/ writerT.listen(readerTask.Functor);
/**
 * @since 3.0.0
 */
exports.pass = 
/*#__PURE__*/ writerT.pass(readerTask.Functor);
/**
 * @since 3.0.0
 */
exports.listens = writerT.listens(readerTask.Functor);
/**
 * @since 3.0.0
 */
exports.censor = 
/*#__PURE__*/ writerT.censor(readerTask.Functor);
// -------------------------------------------------------------------------------------
// type class operations
// -------------------------------------------------------------------------------------
/**
 * @category type class operations
 * @since 3.0.0
 */
exports.map = 
/*#__PURE__*/ writerT.map(readerTask.Functor);
/**
 * Returns an effect with its error channel mapped using the specified
 * function. This can be used to lift a "smaller" error into a "larger" error.
 *
 * @category type class operations
 * @since 3.0.0
 */
exports.mapError = 
/*#__PURE__*/ writerT.mapLeft(readerTask.Functor);
/**
 * Returns an effect whose failure and success channels have been mapped by
 * the specified pair of functions, `f` and `g`.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.mapBoth = writerT.mapBoth(readerTask.Functor);
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    mapBoth: exports.mapBoth
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/ functor.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
var getPointed = function (M) { return ({
    of: writerT.of(readerTask.Pointed, M)
}); };
exports.getPointed = getPointed;
/**
 * @category instances
 * @since 3.0.0
 */
var getApply = function (A, S) { return ({
    map: exports.map,
    ap: writerT.ap(A, S)
}); };
exports.getApply = getApply;
/**
 * @category instances
 * @since 3.0.0
 */
var getApplicative = function (A, M) {
    var ap = (0, exports.getApply)(A, M).ap;
    var P = (0, exports.getPointed)(M);
    return {
        map: exports.map,
        ap: ap,
        of: P.of
    };
};
exports.getApplicative = getApplicative;
/**
 * @category instances
 * @since 3.0.0
 */
var getFlattenable = function (S) {
    return {
        map: exports.map,
        flatMap: writerT.flatMap(readerTask.Flattenable, S)
    };
};
exports.getFlattenable = getFlattenable;
/**
 * @category instances
 * @since 3.0.0
 */
var getMonad = function (M) {
    var P = (0, exports.getPointed)(M);
    var C = (0, exports.getFlattenable)(M);
    return {
        map: exports.map,
        of: P.of,
        flatMap: C.flatMap
    };
};
exports.getMonad = getMonad;
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromWriter = {
    fromWriter: exports.fromWriter
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromWriterK = fromWriter_.fromWriterK(exports.FromWriter);
/**
 * @category instances
 * @since 3.0.0
 */
var getFromReader = function (M) { return ({
    fromReader: (0, exports.fromReader)(M.empty)
}); };
exports.getFromReader = getFromReader;
/**
 * @category instances
 * @since 3.0.0
 */
var getFromIO = function (M) { return ({
    fromIO: (0, exports.fromIO)(M.empty)
}); };
exports.getFromIO = getFromIO;
/**
 * @category instances
 * @since 3.0.0
 */
var getFromTask = function (M) { return ({
    fromIO: (0, exports.fromIO)(M.empty),
    fromTask: (0, exports.fromTask)(M.empty)
}); };
exports.getFromTask = getFromTask;
// -------------------------------------------------------------------------------------
// do notation
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.bindTo = 
/*#__PURE__*/ functor.bindTo(exports.Functor);
var let_ = 
/*#__PURE__*/ functor.let(exports.Functor);
exports.let = let_;
// -------------------------------------------------------------------------------------
// sequence T
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.tupled = 
/*#__PURE__*/ functor.tupled(exports.Functor);
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(getApply(A, M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndex = function (A, S) {
    return function (f) {
        return function (as) {
            // TODO
            return readonlyNonEmptyArray.traverseWithIndex((0, exports.getApply)(A, S))(f)(as);
        };
    };
};
exports.traverseReadonlyNonEmptyArrayWithIndex = traverseReadonlyNonEmptyArrayWithIndex;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(getApplicative(A, M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndex = function (A, M) {
    return function (f) {
        var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(A, M)(f);
        var P = (0, exports.getPointed)(M);
        return function (as) { return (_.isNonEmpty(as) ? g(as) : P.of(_.emptyReadonlyArray)); };
    };
};
exports.traverseReadonlyArrayWithIndex = traverseReadonlyArrayWithIndex;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(getApply(A, M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArray = function (A, S) {
    var traverseReadonlyNonEmptyArrayWithIndexAM = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(A, S);
    return function (f) {
        return traverseReadonlyNonEmptyArrayWithIndexAM(function (_, a) { return f(a); });
    };
};
exports.traverseReadonlyNonEmptyArray = traverseReadonlyNonEmptyArray;
/**
 * Equivalent to `ReadonlyArray#traverse(getApplicative(A, M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArray = function (A, M) {
    var traverseReadonlyArrayWithIndexAM = (0, exports.traverseReadonlyArrayWithIndex)(A, M);
    return function (f) {
        return traverseReadonlyArrayWithIndexAM(function (_, a) { return f(a); });
    };
};
exports.traverseReadonlyArray = traverseReadonlyArray;
/**
 * Equivalent to `ReadonlyArray#sequence(getApplicative(A, M))`.
 *
 * @since 3.0.0
 */
var sequenceReadonlyArray = function (A, M) {
    return (0, exports.traverseReadonlyArray)(A, M)(function_1.identity);
};
exports.sequenceReadonlyArray = sequenceReadonlyArray;
