"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.experiment = exports.peeks = exports.seeks = exports.seek = exports.Comonad = exports.flap = exports.Functor = exports.duplicate = exports.extract = exports.extend = exports.map = void 0;
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * @category Functor
 * @since 3.0.0
 */
var map = function (f) { return function (fa) { return ({
    peek: function (s) { return f(fa.peek(s)); },
    pos: fa.pos
}); }; };
exports.map = map;
/**
 * @category Extendable
 * @since 3.0.0
 */
var extend = function (f) { return function (wa) { return ({
    peek: function (s) { return f({ peek: wa.peek, pos: s }); },
    pos: wa.pos
}); }; };
exports.extend = extend;
/**
 * @category Extract
 * @since 3.0.0
 */
var extract = function (wa) { return wa.peek(wa.pos); };
exports.extract = extract;
/**
 * Derivable from `Extendable`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.duplicate = (0, exports.extend)(function_1.identity);
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = functor.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Comonad = {
    map: exports.map,
    extend: exports.extend,
    extract: exports.extract
};
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * Reposition the focus at the specified position.
 *
 * @since 3.0.0
 */
var seek = function (s) {
    return function (wa) { return ({ peek: wa.peek, pos: s }); };
};
exports.seek = seek;
/**
 * Reposition the focus at the specified position, which depends on the current position.
 *
 * @since 3.0.0
 */
var seeks = function (f) {
    return function (wa) { return ({ peek: wa.peek, pos: f(wa.pos) }); };
};
exports.seeks = seeks;
/**
 * Extract a value from a position which depends on the current position.
 *
 * @since 3.0.0
 */
var peeks = function (f) {
    return function (wa) {
        return wa.peek(f(wa.pos));
    };
};
exports.peeks = peeks;
/**
 * Extract a collection of values from positions which depend on the current position.
 *
 * @since 3.0.0
 */
function experiment(F) {
    return function (f) { return function (wa) {
        return (0, function_1.pipe)(f(wa.pos), F.map(function (s) { return wa.peek(s); }));
    }; };
}
exports.experiment = experiment;
