"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sequenceReadonlyArray = exports.traverseReadonlyArray = exports.traverseReadonlyNonEmptyArray = exports.traverseReadonlyArrayWithIndex = exports.traverseReadonlyNonEmptyArrayWithIndex = exports.ApT = exports.toTuple2 = exports.fromTaskK = exports.FromTask = exports.fromIOK = exports.logError = exports.log = exports.FromIO = exports.fromTheseK = exports.FromThese = exports.fromNullableK = exports.fromNullable = exports.fromEitherK = exports.fromPredicate = exports.fromOptionK = exports.fromOption = exports.FromEither = exports.Bifunctor = exports.Pointed = exports.flap = exports.Functor = exports.getMonad = exports.getFlattenable = exports.getApplicative = exports.getApply = exports.unit = exports.of = exports.mapError = exports.mapBoth = exports.map = exports.swap = exports.matchWithEffect = exports.match = exports.fromTask = exports.fromIO = exports.fromThese = exports.fromEither = exports.fromIOEither = exports.leftIO = exports.rightIO = exports.leftTask = exports.rightTask = exports.both = exports.right = exports.left = void 0;
exports.sequenceReadonlyArraySeq = exports.traverseReadonlyArraySeq = exports.traverseReadonlyNonEmptyArraySeq = exports.traverseReadonlyArrayWithIndexSeq = exports.traverseReadonlyNonEmptyArrayWithIndexSeq = void 0;
var fromEither_ = __importStar(require("./FromEither"));
var fromIO_ = __importStar(require("./FromIO"));
var fromTask_ = __importStar(require("./FromTask"));
var fromThese_ = __importStar(require("./FromThese"));
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var task = __importStar(require("./Task"));
var these = __importStar(require("./These"));
var theseT = __importStar(require("./TheseT"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
exports.left = theseT.left(task.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.right = theseT.right(task.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.both = theseT.both(task.Pointed);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.rightTask = theseT.rightF(task.Functor);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.leftTask = theseT.leftF(task.Functor);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.rightIO = (0, function_1.flow)(task.fromIO, exports.rightTask);
/**
 * @category constructors
 * @since 3.0.0
 */
exports.leftIO = (0, function_1.flow)(task.fromIO, exports.leftTask);
/**
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromIOEither = task.fromIO;
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromEither = task.of;
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromThese = task.of;
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromIO = exports.rightIO;
/**
 * @category constructors
 * @since 3.0.0
 */
exports.fromTask = exports.rightTask;
// -------------------------------------------------------------------------------------
// destructors
// -------------------------------------------------------------------------------------
/**
 * @category destructors
 * @since 3.0.0
 */
exports.match = theseT.match(task.Functor);
/**
 * @category destructors
 * @since 3.0.0
 */
exports.matchWithEffect = theseT.matchWithEffect(task.Monad);
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
exports.swap = theseT.swap(task.Functor);
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * Returns an effect whose success is mapped by the specified `f` function.
 *
 * @category Functor
 * @since 3.0.0
 */
exports.map = theseT.map(task.Functor);
/**
 * Returns an effect whose failure and success channels have been mapped by
 * the specified pair of functions, `f` and `g`.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.mapBoth = 
/*#__PURE__*/ theseT.mapBoth(task.Functor);
/**
 * Returns an effect with its error channel mapped using the specified
 * function. This can be used to lift a "smaller" error into a "larger" error.
 *
 * @category Bifunctor
 * @since 3.0.0
 */
exports.mapError = 
/*#__PURE__*/ theseT.mapLeft(task.Functor);
/**
 * @category Pointed
 * @since 3.0.0
 */
exports.of = exports.right;
/**
 * @since 3.0.0
 */
exports.unit = (0, exports.of)(undefined);
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
var getApply = function (A, S) { return ({
    map: exports.map,
    ap: theseT.ap(A, S)
}); };
exports.getApply = getApply;
/**
 * @category instances
 * @since 3.0.0
 */
var getApplicative = function (A, S) {
    var AS = (0, exports.getApply)(A, S);
    return {
        map: exports.map,
        ap: AS.ap,
        of: exports.of
    };
};
exports.getApplicative = getApplicative;
/**
 * @category instances
 * @since 3.0.0
 */
var getFlattenable = function (S) { return ({
    map: exports.map,
    flatMap: theseT.flatMap(task.Monad, S)
}); };
exports.getFlattenable = getFlattenable;
/**
 * @category instances
 * @since 3.0.0
 */
var getMonad = function (S) {
    var C = (0, exports.getFlattenable)(S);
    return {
        map: exports.map,
        of: exports.of,
        flatMap: C.flatMap
    };
};
exports.getMonad = getMonad;
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/ functor.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Pointed = {
    of: exports.of
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    mapBoth: exports.mapBoth
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromEither = {
    fromEither: exports.fromEither
};
/**
 * Derivable from `FromEither`.
 *
 * @category natural transformations
 * @since 3.0.0
 */
exports.fromOption = 
/*#__PURE__*/ fromEither_.fromOption(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromOptionK = fromEither_.fromOptionK(exports.FromEither);
/**
 * Derivable from `FromEither`.
 *
 * @category constructors
 * @since 3.0.0
 */
exports.fromPredicate = fromEither_.fromPredicate(exports.FromEither);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromEitherK = fromEither_.fromEitherK(exports.FromEither);
/**
 * @category interop
 * @since 3.0.0
 */
exports.fromNullable = 
/*#__PURE__*/ fromEither_.fromNullable(exports.FromEither);
/**
 * @category interop
 * @since 3.0.0
 */
exports.fromNullableK = fromEither_.fromNullableK(exports.FromEither);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromThese = {
    fromThese: exports.fromThese
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromTheseK = fromThese_.fromTheseK(exports.FromThese);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromIO = {
    fromIO: exports.fromIO
};
// -------------------------------------------------------------------------------------
// logging
// -------------------------------------------------------------------------------------
/**
 * @category logging
 * @since 3.0.0
 */
exports.log = fromIO_.log(exports.FromIO);
/**
 * @category logging
 * @since 3.0.0
 */
exports.logError = fromIO_.logError(exports.FromIO);
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromIOK = 
/*#__PURE__*/ fromIO_.fromIOK(exports.FromIO);
/**
 * @category instances
 * @since 3.0.0
 */
exports.FromTask = {
    fromIO: exports.fromIO,
    fromTask: exports.fromTask
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.fromTaskK = fromTask_.fromTaskK(exports.FromTask);
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.toTuple2 = 
/*#__PURE__*/ theseT.toTuple2(task.Functor);
// -------------------------------------------------------------------------------------
// sequence T
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
exports.ApT = (0, exports.of)(_.emptyReadonlyArray);
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
// --- Par ---
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(getApply(T.ApplyPar, S))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndex = function (S) {
    var g = these.traverseReadonlyNonEmptyArrayWithIndex(S);
    return function (f) { return (0, function_1.flow)(task.traverseReadonlyNonEmptyArrayWithIndex(f), task.map(g(function_1.SK))); };
};
exports.traverseReadonlyNonEmptyArrayWithIndex = traverseReadonlyNonEmptyArrayWithIndex;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(getApplicative(T.ApplicativePar, S))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndex = function (S) {
    return function (f) {
        var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(S)(f);
        return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
    };
};
exports.traverseReadonlyArrayWithIndex = traverseReadonlyArrayWithIndex;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(getApply(T.ApplyPar, S))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArray = function (S) {
    var traverseReadonlyNonEmptyArrayWithIndexS = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(S);
    return function (f) {
        return traverseReadonlyNonEmptyArrayWithIndexS(function (_, a) { return f(a); });
    };
};
exports.traverseReadonlyNonEmptyArray = traverseReadonlyNonEmptyArray;
/**
 * Equivalent to `ReadonlyArray#traverse(getApplicative(T.ApplicativePar, S))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArray = function (S) {
    var traverseReadonlyArrayWithIndexS = (0, exports.traverseReadonlyArrayWithIndex)(S);
    return function (f) {
        return traverseReadonlyArrayWithIndexS(function (_, a) { return f(a); });
    };
};
exports.traverseReadonlyArray = traverseReadonlyArray;
/**
 * Equivalent to `ReadonlyArray#sequence(getApplicative(T.ApplicativePar, S))`.
 *
 * @since 3.0.0
 */
var sequenceReadonlyArray = function (S) { return (0, exports.traverseReadonlyArray)(S)(function_1.identity); };
exports.sequenceReadonlyArray = sequenceReadonlyArray;
// --- Seq ---
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(getApply(T.ApplySeq, S))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndexSeq = function (S) {
    return function (f) {
        return function (as) {
            return function () {
                return _.tail(as).reduce(function (acc, a, i) {
                    return acc.then(function (ebs) {
                        return these.isLeft(ebs)
                            ? acc
                            : f(i + 1, a)().then(function (eb) {
                                if (these.isLeft(eb)) {
                                    return eb;
                                }
                                if (these.isBoth(eb)) {
                                    var right_1 = ebs.right;
                                    right_1.push(eb.right);
                                    return these.isBoth(ebs)
                                        ? these.both(S.combine(eb.left)(ebs.left), right_1)
                                        : these.both(eb.left, right_1);
                                }
                                ebs.right.push(eb.right);
                                return ebs;
                            });
                    });
                }, f(0, _.head(as))().then(these.map(_.singleton)));
            };
        };
    };
};
exports.traverseReadonlyNonEmptyArrayWithIndexSeq = traverseReadonlyNonEmptyArrayWithIndexSeq;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(getApplicative(T.ApplicativeSeq, S))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndexSeq = function (S) {
    return function (f) {
        var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndexSeq)(S)(f);
        return function (as) { return (_.isNonEmpty(as) ? g(as) : exports.ApT); };
    };
};
exports.traverseReadonlyArrayWithIndexSeq = traverseReadonlyArrayWithIndexSeq;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(getApply(T.ApplySeq, S))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArraySeq = function (S) {
    var traverseReadonlyNonEmptyArrayWithIndexS = (0, exports.traverseReadonlyNonEmptyArrayWithIndexSeq)(S);
    return function (f) {
        return traverseReadonlyNonEmptyArrayWithIndexS(function (_, a) { return f(a); });
    };
};
exports.traverseReadonlyNonEmptyArraySeq = traverseReadonlyNonEmptyArraySeq;
/**
 * Equivalent to `ReadonlyArray#traverse(getApplicative(T.ApplicativeSeq, S))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArraySeq = function (S) {
    var traverseReadonlyArrayWithIndexS = (0, exports.traverseReadonlyArrayWithIndexSeq)(S);
    return function (f) {
        return traverseReadonlyArrayWithIndexS(function (_, a) { return f(a); });
    };
};
exports.traverseReadonlyArraySeq = traverseReadonlyArraySeq;
/**
 * Equivalent to `ReadonlyArray#sequence(getApplicative(T.ApplicativeSeq, S))`.
 *
 * @since 3.0.0
 */
var sequenceReadonlyArraySeq = function (S) { return (0, exports.traverseReadonlyArraySeq)(S)(function_1.identity); };
exports.sequenceReadonlyArraySeq = sequenceReadonlyArraySeq;
