"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.censor = exports.listens = exports.listen = exports.tracks = exports.getComonad = exports.flap = exports.Functor = exports.map = void 0;
var functor = __importStar(require("./Functor"));
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * @category Functor
 * @since 3.0.0
 */
var map = function (f) { return function (self) { return function (w) { return f(self(w)); }; }; };
exports.map = map;
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/ functor.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
var getComonad = function (M) { return ({
    map: exports.map,
    extend: function (f) { return function (self) { return function (w1) { return f(function (w2) { return self(M.combine(w2)(w1)); }); }; }; },
    extract: function (self) { return self(M.empty); }
}); };
exports.getComonad = getComonad;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * Extracts a value at a relative position which depends on the current value.
 *
 * @since 3.0.0
 */
var tracks = function (M) {
    return function (f) {
        return function (fa) {
            return fa(f(fa(M.empty)));
        };
    };
};
exports.tracks = tracks;
/**
 * Get the current position.
 *
 * @since 3.0.0
 */
var listen = function (fa) {
    return function (w) {
        return [fa(w), w];
    };
};
exports.listen = listen;
/**
 * Get a value which depends on the current position.
 *
 * @since 3.0.0
 */
var listens = function (f) {
    return function (pa) {
        return function (w) {
            return [pa(w), f(w)];
        };
    };
};
exports.listens = listens;
/**
 * Apply a function to the current position.
 *
 * @since 3.0.0
 */
var censor = function (f) {
    return function (pa) {
        return function (w) {
            return pa(f(w));
        };
    };
};
exports.censor = censor;
