"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTraverseComposition = exports.getDefaultSequence = void 0;
var function_1 = require("./function");
// -------------------------------------------------------------------------------------
// defaults
// -------------------------------------------------------------------------------------
/**
 * Return a default `sequence` implementation from `traverse`.
 *
 * @category defaults
 * @since 3.0.0
 */
var getDefaultSequence = function (traverse) {
    return function (G) {
        return traverse(G)(function_1.identity);
    };
};
exports.getDefaultSequence = getDefaultSequence;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * `traverse` composition.
 *
 * @category combinators
 * @since 3.0.0
 */
var getTraverseComposition = function (F, G) {
    return function (H) {
        return function (f) {
            return F.traverse(H)(G.traverse(H)(f));
        };
    };
};
exports.getTraverseComposition = getTraverseComposition;
