"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sequenceReadonlyArray = exports.traverseReadonlyArray = exports.traverseReadonlyNonEmptyArray = exports.traverseReadonlyArrayWithIndex = exports.traverseReadonlyNonEmptyArrayWithIndex = exports.getFlattenableRec = exports.getMonad = exports.getFlattenable = exports.getApplicative = exports.getApply = exports.getPointed = exports.sequence = exports.Traversable = exports.Foldable = exports.Comonad = exports.Composable = exports.flap = exports.Functor = exports.Bifunctor = exports.traverse = exports.reduceRight = exports.foldMap = exports.reduce = exports.duplicate = exports.extract = exports.extend = exports.compose = exports.mapBoth = exports.mapLeft = exports.map = exports.censor = exports.listens = exports.pass = exports.listen = exports.swap = exports.execute = exports.evaluate = exports.snd = exports.fst = exports.tell = void 0;
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
var _ = __importStar(require("./internal"));
var readonlyNonEmptyArrayModule = __importStar(require("./ReadonlyNonEmptyArray"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * Appends a value to the accumulator
 *
 * @category constructors
 * @since 3.0.0
 */
var tell = function (w) { return [w, undefined]; };
exports.tell = tell;
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
var fst = function (self) { return self[0]; };
exports.fst = fst;
/**
 * @since 3.0.0
 */
var snd = function (self) { return self[1]; };
exports.snd = snd;
/**
 * Alias of [`snd`](#snd).
 *
 * @since 3.0.0
 */
exports.evaluate = exports.snd;
/**
 * Alias of [`fst`](#fst).
 *
 * @since 3.0.0
 */
exports.execute = exports.fst;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
var swap = function (self) { return [(0, exports.snd)(self), (0, exports.fst)(self)]; };
exports.swap = swap;
/**
 * Modifies the result to include the changes to the accumulator
 *
 * @category combinators
 * @since 3.0.0
 */
var listen = function (self) {
    var w = self[0], a = self[1];
    return [w, [w, a]];
};
exports.listen = listen;
/**
 * Applies the returned function to the accumulator
 *
 * @category combinators
 * @since 3.0.0
 */
var pass = function (self) {
    var w = self[0], _a = self[1], a = _a[0], f = _a[1];
    return [f(w), a];
};
exports.pass = pass;
/**
 * Projects a value from modifications made to the accumulator during an action
 *
 * @category combinators
 * @since 3.0.0
 */
var listens = function (f) {
    return function (self) {
        var w = self[0], a = self[1];
        return [w, [a, f(w)]];
    };
};
exports.listens = listens;
/**
 * Modify the final accumulator value by applying a function
 *
 * @category combinators
 * @since 3.0.0
 */
var censor = function (f) {
    return function (self) {
        var w = self[0], a = self[1];
        return [f(w), a];
    };
};
exports.censor = censor;
// -------------------------------------------------------------------------------------
// type class operations
// -------------------------------------------------------------------------------------
/**
 * @category Functor
 * @since 3.0.0
 */
var map = function (f) {
    return function (self) {
        var w = self[0], a = self[1];
        return [w, f(a)];
    };
};
exports.map = map;
/**
 * @category Bifunctor
 * @since 3.0.0
 */
var mapLeft = function (f) {
    return function (self) {
        var w = self[0], a = self[1];
        return [f(w), a];
    };
};
exports.mapLeft = mapLeft;
/**
 * @category Bifunctor
 * @since 3.0.0
 */
var mapBoth = function (f, g) {
    return function (self) {
        return [f((0, exports.fst)(self)), g((0, exports.snd)(self))];
    };
};
exports.mapBoth = mapBoth;
/**
 * @category type class operations
 * @since 3.0.0
 */
var compose = function (bc) {
    return function (ab) {
        return [(0, exports.fst)(ab), (0, exports.snd)(bc)];
    };
};
exports.compose = compose;
/**
 * @category type class operations
 * @since 3.0.0
 */
var extend = function (f) {
    return function (self) {
        return [(0, exports.fst)(self), f(self)];
    };
};
exports.extend = extend;
/**
 * @category type class operations
 * @since 3.0.0
 */
exports.extract = exports.snd;
/**
 * Derivable from `Extendable`.
 *
 * @category type class operations
 * @since 3.0.0
 */
exports.duplicate = (0, exports.extend)(function_1.identity);
/**
 * @category type class operations
 * @since 3.0.0
 */
var reduce = function (b, f) {
    return function (self) {
        return f(b, (0, exports.snd)(self));
    };
};
exports.reduce = reduce;
/**
 * @category type class operations
 * @since 3.0.0
 */
var foldMap = function (_M) {
    return function (f) {
        return function (self) {
            return f((0, exports.snd)(self));
        };
    };
};
exports.foldMap = foldMap;
/**
 * @category type class operations
 * @since 3.0.0
 */
var reduceRight = function (b, f) {
    return function (self) {
        return f((0, exports.snd)(self), b);
    };
};
exports.reduceRight = reduceRight;
/**
 * @category type class operations
 * @since 3.0.0
 */
var traverse = function (F) {
    return function (f) {
        return function (self) {
            return (0, function_1.pipe)(f((0, exports.snd)(self)), F.map(function (b) { return [(0, exports.fst)(self), b]; }));
        };
    };
};
exports.traverse = traverse;
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
exports.Bifunctor = {
    mapBoth: exports.mapBoth
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Functor = {
    map: exports.map
};
/**
 * Derivable from `Functor`.
 *
 * @category combinators
 * @since 3.0.0
 */
exports.flap = 
/*#__PURE__*/ functor.flap(exports.Functor);
/**
 * @category instances
 * @since 3.0.0
 */
exports.Composable = {
    compose: exports.compose
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Comonad = {
    map: exports.map,
    extend: exports.extend,
    extract: exports.extract
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Foldable = {
    reduce: exports.reduce,
    foldMap: exports.foldMap,
    reduceRight: exports.reduceRight
};
/**
 * @category instances
 * @since 3.0.0
 */
exports.Traversable = {
    traverse: exports.traverse
};
/**
 * @since 3.0.0
 */
var sequence = function (F) { return (0, exports.traverse)(F)(function_1.identity); };
exports.sequence = sequence;
/**
 * @category instances
 * @since 3.0.0
 */
var getPointed = function (M) { return ({
    of: function (a) { return [M.empty, a]; }
}); };
exports.getPointed = getPointed;
/**
 * @category instances
 * @since 3.0.0
 */
var getApply = function (S) { return ({
    map: exports.map,
    ap: function (fa) { return function (fab) {
        var w1 = fab[0], f = fab[1];
        var w2 = fa[0], a = fa[1];
        return [S.combine(w2)(w1), f(a)];
    }; }
}); };
exports.getApply = getApply;
/**
 * @category instances
 * @since 3.0.0
 */
var getApplicative = function (M) {
    var A = (0, exports.getApply)(M);
    var P = (0, exports.getPointed)(M);
    return {
        map: exports.map,
        ap: A.ap,
        of: P.of
    };
};
exports.getApplicative = getApplicative;
/**
 * @category instances
 * @since 3.0.0
 */
var getFlattenable = function (S) {
    return {
        map: exports.map,
        flatMap: function (f) { return function (ma) {
            var w1 = ma[0], a = ma[1];
            var _a = f(a), w2 = _a[0], b = _a[1];
            return [S.combine(w2)(w1), b];
        }; }
    };
};
exports.getFlattenable = getFlattenable;
/**
 * @category instances
 * @since 3.0.0
 */
var getMonad = function (M) {
    var P = (0, exports.getPointed)(M);
    var C = (0, exports.getFlattenable)(M);
    return {
        map: exports.map,
        of: P.of,
        flatMap: C.flatMap
    };
};
exports.getMonad = getMonad;
/**
 * @category instances
 * @since 3.0.0
 */
function getFlattenableRec(M) {
    var flatMapRec = function (f) {
        return function (a) {
            var result = f(a);
            var acc = M.empty;
            var s = (0, exports.snd)(result);
            while (_.isLeft(s)) {
                acc = M.combine((0, exports.fst)(result))(acc);
                result = f(s.left);
                s = (0, exports.snd)(result);
            }
            return [M.combine((0, exports.fst)(result))(acc), s.right];
        };
    };
    return {
        flatMapRec: flatMapRec
    };
}
exports.getFlattenableRec = getFlattenableRec;
// -------------------------------------------------------------------------------------
// array utils
// -------------------------------------------------------------------------------------
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverseWithIndex(getApply(M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArrayWithIndex = function (S) {
    return function (f) {
        return function (as) {
            // TODO
            return readonlyNonEmptyArrayModule.traverseWithIndex((0, exports.getApply)(S))(f)(as);
        };
    };
};
exports.traverseReadonlyNonEmptyArrayWithIndex = traverseReadonlyNonEmptyArrayWithIndex;
/**
 * Equivalent to `ReadonlyArray#traverseWithIndex(getApplicative(M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArrayWithIndex = function (M) {
    return function (f) {
        var g = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(M)(f);
        return function (as) { return (_.isNonEmpty(as) ? g(as) : [M.empty, _.emptyReadonlyArray]); };
    };
};
exports.traverseReadonlyArrayWithIndex = traverseReadonlyArrayWithIndex;
/**
 * Equivalent to `ReadonlyNonEmptyArray#traverse(getApply(S))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyNonEmptyArray = function (S) {
    var traverseReadonlyNonEmptyArrayWithIndexS = (0, exports.traverseReadonlyNonEmptyArrayWithIndex)(S);
    return function (f) {
        return traverseReadonlyNonEmptyArrayWithIndexS(function (_, a) { return f(a); });
    };
};
exports.traverseReadonlyNonEmptyArray = traverseReadonlyNonEmptyArray;
/**
 * Equivalent to `ReadonlyArray#traverse(getApplicative(M))`.
 *
 * @since 3.0.0
 */
var traverseReadonlyArray = function (M) {
    var traverseReadonlyArrayWithIndexS = (0, exports.traverseReadonlyArrayWithIndex)(M);
    return function (f) {
        return traverseReadonlyArrayWithIndexS(function (_, a) { return f(a); });
    };
};
exports.traverseReadonlyArray = traverseReadonlyArray;
/**
 * Equivalent to `ReadonlyArray#sequence(getApplicative(M))`.
 *
 * @since 3.0.0
 */
var sequenceReadonlyArray = function (M) { return (0, exports.traverseReadonlyArray)(M)(function_1.identity); };
exports.sequenceReadonlyArray = sequenceReadonlyArray;
