"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.censor = exports.listens = exports.pass = exports.listen = exports.swap = exports.snd = exports.fst = exports.mapLeft = exports.mapBoth = exports.flatMap = exports.ap = exports.of = exports.map = exports.tell = exports.fromTask = exports.fromIO = exports.fromF = void 0;
var apply = __importStar(require("./Apply"));
var function_1 = require("./function");
var functor = __importStar(require("./Functor"));
var writer = __importStar(require("./Writer"));
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
function fromF(F) {
    return function (w) { return F.map(function (a) { return [w, a]; }); };
}
exports.fromF = fromF;
/**
 * @category constructors
 * @since 3.0.0
 */
var fromIO = function (F, FT) {
    return function (w) {
        return function (fa) {
            return (0, function_1.pipe)(FT.fromIO(fa), F.map(function (a) { return [w, a]; }));
        };
    };
};
exports.fromIO = fromIO;
/**
 * @category constructors
 * @since 3.0.0
 */
var fromTask = function (F, FT) {
    return function (w) {
        return function (fa) {
            return (0, function_1.pipe)(FT.fromTask(fa), F.map(function (a) { return [w, a]; }));
        };
    };
};
exports.fromTask = fromTask;
/**
 * @category constructors
 * @since 3.0.0
 */
var tell = function (F) {
    return function (w) {
        return F.of(writer.tell(w));
    };
};
exports.tell = tell;
// -------------------------------------------------------------------------------------
// type class operations
// -------------------------------------------------------------------------------------
/**
 * @category type class operations
 * @since 3.0.0
 */
function map(F) {
    return functor.getMapComposition(F, writer.Functor);
}
exports.map = map;
/**
 * @category type class operations
 * @since 3.0.0
 */
function of(F, M) {
    return function (a) { return F.of([M.empty, a]); };
}
exports.of = of;
/**
 * @category type class operations
 * @since 3.0.0
 */
var ap = function (F, S) {
    return apply.getApComposition(F, writer.getApply(S));
};
exports.ap = ap;
/**
 * @category type class operations
 * @since 3.0.0
 */
var flatMap = function (M, S) {
    return function (f) {
        return M.flatMap(function (_a) {
            var w1 = _a[0], a = _a[1];
            return (0, function_1.pipe)(f(a), M.map(function (_a) {
                var w2 = _a[0], b = _a[1];
                return [S.combine(w2)(w1), b];
            }));
        });
    };
};
exports.flatMap = flatMap;
/**
 * Returns an effect whose failure and success channels have been mapped by
 * the specified pair of functions, `f` and `g`.
 *
 * @category type class operations
 * @since 3.0.0
 */
var mapBoth = function (F) {
    return function (f, g) { return F.map(writer.mapBoth(f, g)); };
};
exports.mapBoth = mapBoth;
/**
 * @category type class operations
 * @since 3.0.0
 */
var mapLeft = function (F) {
    return function (f) {
        return F.map(writer.mapLeft(f));
    };
};
exports.mapLeft = mapLeft;
// TODO: concatK, emptyK, fromEither, fromReader, fromState, reduce, foldMap, reduceRight, traverse, contramap
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
function fst(F) {
    return F.map(writer.fst);
}
exports.fst = fst;
/**
 * @since 3.0.0
 */
function snd(F) {
    return F.map(writer.snd);
}
exports.snd = snd;
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
function swap(F) {
    return F.map(writer.swap);
}
exports.swap = swap;
/**
 * Modifies the result to include the changes to the accumulator
 *
 * @category combinators
 * @since 3.0.0
 */
function listen(F) {
    return F.map(writer.listen);
}
exports.listen = listen;
/**
 * Applies the returned function to the accumulator
 *
 * @category combinators
 * @since 3.0.0
 */
function pass(F) {
    return F.map(writer.pass);
}
exports.pass = pass;
/**
 * Projects a value from modifications made to the accumulator during an action
 *
 * @category combinators
 * @since 3.0.0
 */
function listens(F) {
    return function (f) { return F.map(writer.listens(f)); };
}
exports.listens = listens;
/**
 * Modify the final accumulator value by applying a function
 *
 * @category combinators
 * @since 3.0.0
 */
function censor(F) {
    return function (f) { return F.map(writer.censor(f)); };
}
exports.censor = censor;
