/**
 * @since 3.0.0
 */
import { identity } from './function';
// -------------------------------------------------------------------------------------
// defaults
// -------------------------------------------------------------------------------------
/**
 * Returns a default `mapLeft` implementation from `mapBoth`.
 *
 * @category defaults
 * @since 3.0.0
 */
export const getDefaultMapLeft = (mapBoth) => (f) => mapBoth(f, identity);
/**
 * Returns a default `map` implementation from `mapBoth`.
 *
 * @category defaults
 * @since 3.0.0
 */
export const getDefaultMap = (mapBoth) => (f) => mapBoth(identity, f);
