import * as ord from './Ord';
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * Clamp a value between `bottom` and `top` values.
 *
 * @category utils
 * @since 3.0.0
 */
export const clamp = (B) => ord.clamp(B)(B.bottom, B.top);
/**
 * Reverses the `Ord` of a `Bounded` and swaps `top` and `bottom` values.
 *
 * @category utils
 * @since 3.0.0
 */
export const reverse = (B) => {
    const R = ord.reverse(B);
    return {
        compare: R.compare,
        top: B.bottom,
        bottom: B.top
    };
};
