// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * The *greatest common divisor* of two values.
 *
 * @since 3.0.0
 */
export const gcd = (E, F) => {
    const predicate = E.equals(F.zero);
    const f = (second) => (self) => predicate(second) ? self : f(F.mod(second)(self))(second);
    return f;
};
/**
 * The *least common multiple* of two values.
 *
 * @since 3.0.0
 */
export const lcm = (E, F) => {
    const zero = F.zero;
    const predicate = E.equals(zero);
    const gcdSF = gcd(E, F);
    return (second) => (first) => predicate(first) || predicate(second) ? zero : F.div(gcdSF(second)(first))(F.mul(second)(first));
};
