import { pipe } from './function';
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
export const ap = (M) => (fa) => (fab) => pipe(fab, M.flatMap((f) => pipe(fa, M.map(f))));
/**
 * Returns an effect that effectfully "peeks" at the success of this effect.
 *
 * @category combinators
 * @since 3.0.0
 */
export const tap = (M) => (f) => M.flatMap((a) => pipe(f(a), M.map(() => a)));
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
export const bind = (M) => (name, f) => M.flatMap((a) => pipe(f(a), M.map((b) => Object.assign({}, a, { [name]: b }))));
