import { pipe } from './function';
import * as console from './Console';
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
export const fromIOK = (F) => (f) => (...a) => F.fromIO(f(...a));
/**
 * @category combinators
 * @since 3.0.0
 */
export const flatMapIOK = (F, M) => (f) => (self) => {
    return pipe(self, M.flatMap((a) => F.fromIO(f(a))));
};
// -------------------------------------------------------------------------------------
// logging
// -------------------------------------------------------------------------------------
/**
 * @category logging
 * @since 3.0.0
 */
export const log = (F) => (...x) => F.fromIO(console.log(...x));
/**
 * @category logging
 * @since 3.0.0
 */
export const logError = (F) => (...x) => F.fromIO(console.error(...x));
