import { pipe } from './function';
import * as _ from './internal';
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
export function ask(F) {
    return () => F.fromReader(_.ask());
}
/**
 * @category constructors
 * @since 3.0.0
 */
export function asks(F) {
    return F.fromReader;
}
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * @category combinators
 * @since 3.0.0
 */
export const fromReaderK = (F) => (f) => (...a) => F.fromReader(f(...a));
/**
 * @category combinators
 * @since 3.0.0
 */
export const flatMapReaderK = (F, M) => (f) => (self) => {
    return pipe(self, M.flatMap((a) => F.fromReader(f(a))));
};
