/**
 * TODO: description
 *
 * `MonoidK` instances should satisfy the following laws in addition to the `SemigroupK` laws:
 *
 * 1. Left identity: `emptyK |> combineK(() => fa) <-> fa`
 * 2. Right identity: `fa |> combineK(() => emptyK) <-> fa`
 * 3. Annihilation1: `emptyK |> map(f) <-> emptyK`
 * 4. Distributivity: `fab |> combineK(() => gab) |> ap(fa) <-> fab |> ap(fa) |> combineK(() => gab |> A.ap(fa))`
 * 5. Annihilation2: `emptyK |> ap(fa) <-> emptyK`
 *
 * @since 3.0.0
 */
import * as semigroupK from './SemigroupK';
// -------------------------------------------------------------------------------------
// constructors
// -------------------------------------------------------------------------------------
/**
 * @category constructors
 * @since 3.0.0
 */
export const guard = (F, P) => (b) => b ? P.of(undefined) : F.emptyK();
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
export const combineKAll = (F) => {
    const combineKAllF = semigroupK.combineKAll(F);
    return (as) => {
        return combineKAllF(F.emptyK())(as);
    };
};
