import { constFalse, constTrue, flow } from './function';
// -------------------------------------------------------------------------------------
// type class members
// -------------------------------------------------------------------------------------
/**
 * @category Contravariant
 * @since 3.0.0
 */
export const contramap = (f) => (predicate) => flow(f, predicate);
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @category instances
 * @since 3.0.0
 */
export const getSemigroupAny = () => ({
    combine: or
});
/**
 * @category instances
 * @since 3.0.0
 */
export const getMonoidAny = () => ({
    combine: getSemigroupAny().combine,
    empty: constFalse
});
/**
 * @category instances
 * @since 3.0.0
 */
export const getSemigroupAll = () => ({
    combine: and
});
/**
 * @category instances
 * @since 3.0.0
 */
export const getMonoidAll = () => ({
    combine: getSemigroupAll().combine,
    empty: constTrue
});
/**
 * @category instances
 * @since 3.0.0
 */
export const Contravariant = {
    contramap
};
// -------------------------------------------------------------------------------------
// utils
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
export const not = (predicate) => (a) => !predicate(a);
/**
 * @since 3.0.0
 */
export const or = (second) => (self) => (a) => self(a) || second(a);
/**
 * @since 3.0.0
 */
export const and = (second) => (self) => (a) => self(a) && second(a);
