import * as _ from './internal';
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
/**
 * @since 3.0.0
 */
export const contramap = (f) => (self) => ({
    show: (b) => self.show(f(b))
});
/**
 * @category instances
 * @since 3.0.0
 */
export const Contravariant = {
    contramap
};
/**
 * @category combinators
 * @since 3.0.0
 */
export const struct = (shows) => ({
    show: (a) => {
        let s = '{';
        for (const k in shows) {
            if (_.has.call(shows, k)) {
                s += ` ${k}: ${shows[k].show(a[k])},`;
            }
        }
        if (s.length > 1) {
            s = s.slice(0, -1) + ' ';
        }
        s += '}';
        return s;
    }
});
/**
 * @category combinators
 * @since 3.0.0
 */
export const tuple = (...shows) => ({
    show: (t) => `[${t.map((a, i) => shows[i].show(a)).join(', ')}]`
});
