import { flow, pipe } from './function';
import * as writer from './Writer';
/**
 * @since 3.0.0
 */
export function of(F) {
    return (a) => (s) => F.of([s, a]);
}
/**
 * @since 3.0.0
 */
export function map(F) {
    return (f) => (fa) => flow(fa, F.map(([s1, a]) => [s1, f(a)]));
}
/**
 * @since 3.0.0
 */
export const ap = (F) => (fa) => (fab) => {
    return (s) => pipe(fab(s), F.flatMap(([s1, f]) => pipe(fa(s1), F.map(([s2, a]) => [s2, f(a)]))));
};
/**
 * @since 3.0.0
 */
export const flatMap = (F) => (f) => (ma) => {
    return (s) => pipe(ma(s), F.flatMap(([s1, a]) => f(a)(s1)));
};
/**
 * @since 3.0.0
 */
export function fromState(F) {
    return (sa) => (s) => F.of(sa(s));
}
/**
 * @since 3.0.0
 */
export function fromF(F) {
    return (self) => (s) => pipe(self, F.map((a) => [s, a]));
}
/**
 * @since 3.0.0
 */
export function evaluate(F) {
    return (s) => (ma) => pipe(ma(s), F.map(writer.snd));
}
/**
 * @since 3.0.0
 */
export function execute(F) {
    return (s) => (ma) => pipe(ma(s), F.map(writer.fst));
}
