import { identity } from './function';
// -------------------------------------------------------------------------------------
// defaults
// -------------------------------------------------------------------------------------
/**
 * Return a default `sequence` implementation from `traverse`.
 *
 * @category defaults
 * @since 3.0.0
 */
export const getDefaultSequence = (traverse) => (G) => {
    return traverse(G)(identity);
};
// -------------------------------------------------------------------------------------
// combinators
// -------------------------------------------------------------------------------------
/**
 * `traverse` composition.
 *
 * @category combinators
 * @since 3.0.0
 */
export const getTraverseComposition = (F, G) => (H) => (f) => {
    return F.traverse(H)(G.traverse(H)(f));
};
