import type { Apply } from './Apply'
import type { TypeLambda, Kind } from './HKT'
import type { Monoid } from './Monoid'
import type { Pointed } from './Pointed'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface Applicative<F extends TypeLambda> extends Apply<F>, Pointed<F> {}
/**
 * Lift a monoid into 'F', the inner values are combined using the provided `Monoid`.
 *
 * @since 3.0.0
 */
export declare const getApplicativeMonoid: <F extends TypeLambda>(
  F: Applicative<F>
) => <A, S, R, W, E>(M: Monoid<A>) => Monoid<Kind<F, S, R, W, E, A>>
