import type { Functor } from './Functor'
import type { TypeLambda, Kind, TypeClass } from './HKT'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface Bifunctor<F extends TypeLambda> extends TypeClass<F> {
  readonly mapBoth: <E, G, A, B>(
    f: (e: E) => G,
    g: (a: A) => B
  ) => <S, R, W>(self: Kind<F, S, R, W, E, A>) => Kind<F, S, R, W, G, B>
}
/**
 * Returns a default `mapLeft` implementation from `mapBoth`.
 *
 * @category defaults
 * @since 3.0.0
 */
export declare const getDefaultMapLeft: <F extends TypeLambda>(
  mapBoth: <E, G, A, B>(
    f: (e: E) => G,
    g: (a: A) => B
  ) => <S, R, W>(self: Kind<F, S, R, W, E, A>) => Kind<F, S, R, W, G, B>
) => <E_1, G_1>(
  f: (e: E_1) => G_1
) => <S_1, R_1, W_1, A_1>(self: Kind<F, S_1, R_1, W_1, E_1, A_1>) => Kind<F, S_1, R_1, W_1, G_1, A_1>
/**
 * Returns a default `map` implementation from `mapBoth`.
 *
 * @category defaults
 * @since 3.0.0
 */
export declare const getDefaultMap: <F extends TypeLambda>(
  mapBoth: <E, G, A, B>(
    f: (e: E) => G,
    g: (a: A) => B
  ) => <S, R, W>(self: Kind<F, S, R, W, E, A>) => Kind<F, S, R, W, G, B>
) => <A_1, B_1>(
  f: (a: A_1) => B_1
) => <S_1, R_1, O, E_1>(self: Kind<F, S_1, R_1, O, E_1, A_1>) => Kind<F, S_1, R_1, O, E_1, B_1>
