/**
 * @since 3.0.0
 */
import type { TypeLambda } from './HKT'
import type { Monoid } from './Monoid'
import type { Semigroup } from './Semigroup'
/**
 * @since 3.0.0
 */
export interface Endomorphism<A> {
  (a: A): A
}
/**
 * @category type lambdas
 * @since 3.0.0
 */
export interface Endomorphismλ extends TypeLambda {
  readonly type: Endomorphism<this['InOut1']>
}
/**
 * Endomorphism form a `Semigroup` where the `combine` operation is the usual function composition.
 *
 * @category instances
 * @since 3.0.0
 */
export declare const getSemigroup: <A = never>() => Semigroup<Endomorphism<A>>
/**
 * Endomorphism form a `Monoid` where the `empty` value is the `identity` function.
 *
 * @category instances
 * @since 3.0.0
 */
export declare const getMonoid: <A = never>() => Monoid<Endomorphism<A>>
