/**
 * @since 3.0.0
 */
import type { Either } from './Either'
import type { TypeLambda, Kind, TypeClass } from './HKT'
import type { Option } from './Option'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface FilterableWithIndex<F extends TypeLambda, I> extends TypeClass<F> {
  readonly partitionMapWithIndex: <A, B, C>(
    f: (i: I, a: A) => Either<B, C>
  ) => <S, R, W, E>(self: Kind<F, S, R, W, E, A>) => readonly [Kind<F, S, R, W, E, B>, Kind<F, S, R, W, E, C>]
  readonly filterMapWithIndex: <A, B>(
    f: (i: I, a: A) => Option<B>
  ) => <S, R, W, E>(self: Kind<F, S, R, W, E, A>) => Kind<F, S, R, W, E, B>
}
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const filterWithIndex: <F extends TypeLambda, I>(
  F: FilterableWithIndex<F, I>
) => {
  <C extends A, B extends A, A = C>(refinement: (i: I, a: A) => a is B): <S, R, W, E>(
    fc: Kind<F, S, R, W, E, C>
  ) => Kind<F, S, R, W, E, B>
  <B extends A, A = B>(predicate: (i: I, a: A) => boolean): <S, R, W, E>(
    fb: Kind<F, S, R, W, E, B>
  ) => Kind<F, S, R, W, E, B>
}
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const partitionWithIndex: <F extends TypeLambda, I>(
  F: FilterableWithIndex<F, I>
) => {
  <C extends A, B extends A, A = C>(refinement: (i: I, a: A) => a is B): <S, R, W, E>(
    fb: Kind<F, S, R, W, E, C>
  ) => readonly [Kind<F, S, R, W, E, C>, Kind<F, S, R, W, E, B>]
  <B extends A, A = B>(predicate: (i: I, a: A) => boolean): <S, R, W, E>(
    fb: Kind<F, S, R, W, E, B>
  ) => readonly [Kind<F, S, R, W, E, B>, Kind<F, S, R, W, E, B>]
}
