/**
 * @since 3.0.0
 */
import type { Either } from './Either'
import type { TypeLambda, Kind, TypeClass } from './HKT'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface FlattenableRec<F extends TypeLambda> extends TypeClass<F> {
  readonly flatMapRec: <A, S, R, W, E, B>(
    f: (a: A) => Kind<F, S, R, W, E, Either<A, B>>
  ) => (a: A) => Kind<F, S, R, W, E, B>
}
/**
 * @since 3.0.0
 */
export declare const tailRec: <A, B>(f: (a: A) => Either<A, B>) => (startWith: A) => B
