/**
 * Lift a computation from the `Task` monad.
 *
 * @since 3.0.0
 */
import type { Flattenable } from './Flattenable'
import type { FromIO } from './FromIO'
import type { TypeLambda, Kind } from './HKT'
import type { Task } from './Task'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface FromTask<F extends TypeLambda> extends FromIO<F> {
  readonly fromTask: <A, S>(fa: Task<A>) => Kind<F, S, unknown, never, never, A>
}
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const fromTaskK: <F extends TypeLambda>(
  F: FromTask<F>
) => <A extends readonly unknown[], B>(f: (...a: A) => Task<B>) => <S>(...a: A) => Kind<F, S, unknown, never, never, B>
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const flatMapTaskK: <M extends TypeLambda>(
  F: FromTask<M>,
  M: Flattenable<M>
) => <A, B>(f: (a: A) => Task<B>) => <S, R, W, E>(self: Kind<M, S, R, W, E, A>) => Kind<M, S, R, W, E, B>
