/**
 * The `FromWriter` type class represents those data types which support accumulators.
 *
 * @since 3.0.0
 */
import type { TypeLambda, Kind, TypeClass } from './HKT'
import type { Writer } from './Writer'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface FromWriter<F extends TypeLambda> extends TypeClass<F> {
  readonly fromWriter: <E, A, S>(fa: Writer<E, A>) => Kind<F, S, unknown, never, E, A>
}
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const fromWriterK: <F extends TypeLambda>(
  F: FromWriter<F>
) => <A extends readonly unknown[], E, B>(
  f: (...a: A) => Writer<E, B>
) => <S>(...a: A) => Kind<F, S, unknown, never, E, B>
