import type { TypeLambda, Kind, TypeClass } from './HKT'
/**
 * @category type classes
 * @since 3.0.0
 */
export interface FunctorWithIndex<F extends TypeLambda, I> extends TypeClass<F> {
  readonly mapWithIndex: <A, B>(
    f: (i: I, a: A) => B
  ) => <S, R, W, E>(self: Kind<F, S, R, W, E, A>) => Kind<F, S, R, W, E, B>
}
/**
 * `mapWithIndex` composition.
 *
 * @category combinators
 * @since 3.0.0
 */
export declare const getMapWithIndexComposition: <F extends TypeLambda, I, G extends TypeLambda, J>(
  F: FunctorWithIndex<F, I>,
  G: FunctorWithIndex<G, J>
) => <A, B>(
  f: (i: readonly [I, J], a: A) => B
) => <FS, FR, FW, FE, GS, GR, GW, GE>(
  fga: Kind<F, FS, FR, FW, FE, Kind<G, GS, GR, GW, GE, A>>
) => Kind<F, FS, FR, FW, FE, Kind<G, GS, GR, GW, GE, B>>
