/**
 * @since 3.0.0
 */
import * as eq from './Eq'
import type { LazyArg } from './function'
import type * as monoid from './Monoid'
import type * as semigroup from './Semigroup'
/**
 * @category model
 * @since 3.0.0
 */
export declare type Ordering = -1 | 0 | 1
/**
 * @category combinators
 * @since 3.0.0
 */
export declare const reverse: (o: Ordering) => Ordering
/**
 * @category destructors
 * @since 3.0.0
 */
export declare const match: <A, B, C = B>(
  onLessThan: LazyArg<A>,
  onEqual: LazyArg<B>,
  onGreaterThan: LazyArg<C>
) => (o: Ordering) => A | B | C
/**
 * @category instances
 * @since 3.0.0
 */
export declare const Eq: eq.Eq<Ordering>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const Semigroup: semigroup.Semigroup<Ordering>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const Monoid: monoid.Monoid<Ordering>
/**
 * @since 3.0.0
 */
export declare const sign: (n: number) => Ordering
