/**
 * @since 3.0.0
 */
import type * as contravariant from './Contravariant'
import type { TypeLambda } from './HKT'
import type { Monoid } from './Monoid'
import type { Semigroup } from './Semigroup'
/**
 * @since 3.0.0
 */
export interface Predicate<A> {
  (a: A): boolean
}
/**
 * @category Contravariant
 * @since 3.0.0
 */
export declare const contramap: <B, A>(f: (b: B) => A) => (fa: Predicate<A>) => Predicate<B>
/**
 * @category type lambdas
 * @since 3.0.0
 */
export interface Predicateλ extends TypeLambda {
  readonly type: Predicate<this['In1']>
}
/**
 * @category instances
 * @since 3.0.0
 */
export declare const getSemigroupAny: <A = never>() => Semigroup<Predicate<A>>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const getMonoidAny: <A = never>() => Monoid<Predicate<A>>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const getSemigroupAll: <A = never>() => Semigroup<Predicate<A>>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const getMonoidAll: <A = never>() => Monoid<Predicate<A>>
/**
 * @category instances
 * @since 3.0.0
 */
export declare const Contravariant: contravariant.Contravariant<Predicateλ>
/**
 * @since 3.0.0
 */
export declare const not: <A>(predicate: Predicate<A>) => Predicate<A>
/**
 * @since 3.0.0
 */
export declare const or: <A>(second: Predicate<A>) => (self: Predicate<A>) => Predicate<A>
/**
 * @since 3.0.0
 */
export declare const and: <A>(second: Predicate<A>) => (self: Predicate<A>) => Predicate<A>
